/*****************************************************************************

				WWIV Version 4
		      Copyright (C) 1988 by Wayne Bell

Distribution of the source code for WWIV, in any form, modified or unmodified,
without PRIOR, WRITTEN APPROVAL by the author, is expressly prohibited.
Distribution of compiled versions of WWIV is limited to copies compiled BY
THE AUTHOR.  Distribution of any copies of WWIV not compiled by the author
is expressly prohibited.


*****************************************************************************/



#include <stdlib.h>
#include <sys\stat.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include <alloc.h>
#include <dir.h>
#include <math.h>
#include <time.h>
#include "vardec.h"
#include "fcns.h"
#include "net.h"

extern int outcom,incom,dlf,okskey,input_extern,chat_file,two_color;
extern int charbufferpointer,screenlinest,restoring_shrink;
extern int hangup,hungup,using_modem;
extern int checkit,in_extern,live_user;
extern unsigned char andwith;
extern int topline,okmacro;
extern int curatr,num_sec;
extern int ansiptr,helpl,high_speed;
extern int oldx,oldy,change_color,use_workspace,oklevel,noklevel;
extern char endofline[81],cdir[81],crttype;
extern char far *scrn;
extern statusrec status;
extern configrec syscfg;
extern userrec thisuser;
extern int topdata,chatcall,sysop_alert,global_handle;
extern char chatreason[81];
extern int usernum,ihelp;
extern double timeon,extratimecall;
extern int userfile,configfile,statusfile;
extern int useron,wfc,echo,lecho;
extern subboardrec subboards[32];
extern directoryrec directories[64];
extern usersubrec usub[32],udir[64];
extern int num_subs,num_dirs,chatting,okskey,lines_listed;
extern char dc[81],dcd[81];
extern smalrec *smallist;
extern char curspeed[80];
extern int curlsub,curldir,fwaiting,mailcheck,smwcheck;
extern char irt[81];
extern postrec *msgs;
extern gfiledirrec *gfilesec;
extern messagerec menus[30],menus1[30],menus2[30];
extern messagerec helps[50];
extern chainfilerec *chains;
extern externalrec *externs;
extern int numextrn, numchain,screenlen;
extern int checkext[10];
extern int checked[50];
extern unsigned char agemin,agemax,slmin,slmax,dslmin,dslmax,ressex;
extern int daysmin,daysmax,numed,screenbottom,defscreenbottom,flow_control;
extern unsigned short arres,darres,resres;
extern editorrec *editors,*backuped;
extern char gatfn[81],ver_no[21],ver_no1[51];
extern char *xenviron[50],newprompt[161];
extern int questused[20];
extern double last_time,time_event;
extern int do_event,num_ncn,ok_modem_stuff,num_result_codes;
extern net_contact_rec *ncn;
extern screentype screensave;
extern unsigned char realsl,actsl;
extern void far *funcs[25];
extern resultrec *result_codes;


/* functions for external programs to call */

#pragma warn -par

void far interrupt inlii(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, char *s2, int i1, int i2)
{
  inli(s1,s2,i1,i2);
}

void far interrupt checkai(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int *i1, int *i2)
{
  checka(i1,i2);
}


void far interrupt plai(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, int *i1)
{
  pla(s1,i1);
}


void far interrupt outchri(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char ch)
{
  outchr(ch);
}


void far interrupt outstri(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1)
{
  outstr(s1);
}


void far interrupt nli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  nl();
}


void far interrupt pli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1)
{
  pl(s1);
}


void far interrupt emptyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=empty();
}


void far interrupt inkeyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=(unsigned) empty();
}


void far interrupt getkeyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=(unsigned) getkey();
}


void far interrupt inputi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, int i)
{
  input(s1,i);
}


void far interrupt inputli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, int i)
{
  inputl(s1,i);
}


void far interrupt yni(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=yn();
}



void far interrupt nyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=ny();
}


void far interrupt ansici(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int i1)
{
  ansic(i1);
}


void far interrupt oneki(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1)
{
  ax=(unsigned) onek(s1);
}


void far interrupt prti(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int i1, char *s1)
{
  prt(i1,s1);
}



void far interrupt mpli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int i1)
{
  mpl(i1);
}


#pragma warn +par

/* end of functions for external programs to call */


void remove_from_temp(char *fn, int po)
{
  int i,i1,f1,ok;
  char s[81],s1[81];
  struct ffblk ff;
  uploadsrec u;

  strcpy(s1,syscfg.tempdir);
  strcpy(s,stripfn(fn));
  strcat(s1,s);
  f1=findfirst(s1,&ff,0);
  ok=1;
  nl();
  while ((f1==0) && (ok)) {
    strcpy(s,syscfg.tempdir);
    strcat(s,(ff.ff_name));
    strcpy(s1,"Deleting ");
    strcat(s1,ff.ff_name);
    if (po)
      pl(s1);
    unlink(s);
    f1=findnext(&ff);
  }
}

void check_event()
{
  double tl;

  if (syscfg.executetime) {
    tl=time_event-timer();
    if (tl<0.0)
      tl += 24.0*3600.0;
    if ((tl-last_time)>2.0)
      do_event=1;
    last_time=tl;
  }
}


void run_event()
{
  if ((do_event) && (syscfg.executetime)) {
    do_event=0;
    nl();
    pl("Now running external event.");
    nl();
    if (syscfg.executestr[0]) {
      holdphone(1);
      shrink_out(syscfg.executestr,0,0,0,1);
      holdphone(0);
    } else
      end_bbs(oklevel);
  }
  clrscrb();
}


double freek(int dr)
{
  float d;
  struct dfree df;

  getdfree(dr,&df);
  d=(float) df.df_avail;
  d*=((float) df.df_bsec);
  d*=((float) df.df_sclus);
  d/=1024.0;
  if (df.df_sclus<0)
  d=-1.0;
  return(d);
}


unsigned char years_old(unsigned char m, unsigned char d, unsigned char y)
{
  struct date today;
  int a;

  getdate(&today);
  a=(int) (today.da_year-1900-y);
  if (today.da_mon<m)
    --a;
  else
    if ((today.da_mon==m) && (today.da_day<d))
      --a;
  return((unsigned char)a);
}



void itimer()
/* This function initializes the high-resolution timer */
{
  outportb(0x43,0x34);
  outportb(0x40,0x00);
  outportb(0x40,0x00);

}

double timer()
/* This function returns the time, in seconds since midnight. */
{
  double cputim;
  unsigned short int h,m,l1,l2;

  disable();
  outportb(0x43,0x00);
  m=peek(0x0040,0x006c);
  h=peek(0x0040,0x006e);
  l1=inportb(0x40);
  l2=inportb(0x40);
  enable();
  l1=((l2*256)+l1) ^ 65535;
  cputim=((h*65536. + m)*65536. + l1)*8.380955e-7;
  return (cputim);
}


long timer1()
/* This function returns the time, in seconds since midnight. */
{
  unsigned short h,m;
  long l;

  m=peek(0x0040,0x006c);
  h=peek(0x0040,0x006e);
  l=((long)h)*65536 + ((long)m);
  return(l);
}


int sysop1()
/* This function returns the status of scoll lock.  If scroll lock is active
 * (ie, the user has hit scroll lock + the light is lit if there is a
 * scoll lock LED), the sysop is assumed to be available.
 */
{
  if ((peekb(0,1047) & 0x10)==0)
    return(0);
  else
    return(1);
}



int okansi()
/* This function checks the status of the current user's record to see if
 * the user has specified that he wants ANSI graphics displayed.
 */
{
  if (thisuser.sysstatus & sysstatus_ansi)
    return(1);
  else
    return(0);
}


void frequent_init()
/* This should be called after a user is logged off, and will initialize
 * screen-access variables.
 */
{
  ansiptr=0;
  curatr=0x07;
  outcom=0;
  incom=0;
  charbufferpointer=0;
  andwith=0xff;
  checkit=0;
  topline=0;
  screenlinest=defscreenbottom+1;
  if (!restoring_shrink)
    clrscrb();
  endofline[0]=0;
  hangup=0;
  hungup=0;
  chatcall=0;
  chatreason[0]=0;
  useron=0;
  change_color=0;
  chatting=0;
  echo=1;
  irt[0]=0;
  okskey=0;
  lines_listed=0;
  read_user(1,&thisuser);
  if (thisuser.inact & inact_deleted)
    fwaiting=0;
  else
    fwaiting=thisuser.waiting;
  okmacro=1;
  okskey=1;
  helpl=0;
  ihelp=0;
  mailcheck=0;
  smwcheck=0;
  in_extern=0;
  gatfn[0]=0;
  use_workspace=0;
  extratimecall=0.0;
  two_color=0;
  using_modem=0;
  set_global_handle(0);
  live_user=1;
}


void read_in_file(char *fn, messagerec *m, int maxary)
{
  int i,i1,i2;
  char *buf,s[81];
  long l;

  for (i=0; i<maxary; i++) {
    m[i].stored_as=0L;
    m[i].storage_type=255;
  }
  strcpy(s,syscfg.gfilesdir);
  strcat(s,fn);
  i=open(s,O_RDWR | O_BINARY);
  if (i<0) {
    printf("%s NOT FOUND.\n",s);
    end_bbs(noklevel);
  }
  l=filelength(i);
  buf=(char *) farmalloc(l);
  lseek(i,0L,SEEK_SET);
  if (buf==NULL) {
    printf("NOT ENOUGH MEMORY.\n");
    end_bbs(noklevel);
  }
  read(i,(void *) buf,l);
  close(i);
  i1=0;
  for (i=0; i<(int)l; i++) {
    if (buf[i]=='`') {
      i1=1;
      i2=0;
    } else
      if (i1) {
        if ((buf[i]>='0') && (buf[i]<='9')) {
          i2*=10;
          i2+=(buf[i])-'0';
        } else {
          while ((i<(int)l) && (buf[i]!=10))
            ++i;
          ++i;
          if ((i2>=0) && (i2<maxary))
            m[i2].stored_as=(long)i;
          i1=0;
        }
      }
  }
  farfree((void *) buf);
}


void far *mallocx(unsigned long l)
{
  void *x;

  x=farmalloc(l);
  if (!x) {
    printf("NOT ENOUGH MEMORY.\n");
    end_bbs(noklevel);
  }
  return(x);
}


void init(int x)
{
  char s[81], *buf,ch,*ss;
  int i,i1,i2,sm,cp,n,f;
  long l;
  union REGS r;
  struct date today;
  votingrec v;


  crttype=peekb(0x0040,0x0049);
  if (crttype==7)
    scrn=MK_FP(0xb000,0x0000);
  else
    scrn=MK_FP(0xb800,0x0000);
  r.h.ah=15;
  int86(0x10,&r,&r);
  sm=r.h.al;
  if (r.h.ah!=80) {
    printf("\n\nYou must be in 80 column mode to run WWIV.\n\n");
    end_bbs(noklevel);
  }
  if ((sm==4) || (sm==5) || (sm==6)) {
    printf("\n\nYou must be in text mode to run WWIV.\n\n");
    end_bbs(noklevel);
  }
  defscreenbottom=(int) peekb(0x0000,0x0484);
  if (defscreenbottom<24)
    defscreenbottom=24;
  if (defscreenbottom>63)
    defscreenbottom=24;
  if ((defscreenbottom!=42) && (defscreenbottom!=49))
    defscreenbottom=24;
  screenbottom=defscreenbottom;
  screenlen=160*(screenbottom+1);
  if (!exist("restore.wwv")) {
    for (i=0; i<screenbottom; i++)
      printf("\n");
    strcpy(s,VERSION_NUMBER);
    strcat(s,", Copyright (c) 1988 by Wayne Bell.\n\n");
    printf(s);
  }
  strcpy(cdir,"X:\\");
  cdir[0]='A'+getdisk();
  getcurdir(0,&(cdir[3]));
  userfile=-1;
  configfile=-1;
  statusfile=-1;
  dlf=-1;
  curlsub=-1;
  curldir=-1;
  setvect(0x68,getvect(0x10));
  setvect(0x69,getvect(0x21));
  oldx=0;
  oldy=0;
  itimer();
  r.h.ah=0x33;
  r.h.al=0x01;
  r.h.dl=0x00;
  int86(0x21,&r,&r);
  agemin=0;
  agemax=255;
  slmin=0;
  slmax=255;
  dslmin=0;
  dslmax=255;
  ressex=0;
  daysmin=0;
  daysmax=9999;
  arres=0;
  darres=0;
  resres=0;
  use_workspace=0;
  input_extern=0;
  chat_file=0;
  do_event=0;
  sysop_alert=0;
  ncn=NULL;
  num_ncn=0;
  global_handle=0;

  if (x) {
    for (i=0; i<25; i++)
      funcs[i]=NULL;
    funcs[0]=(void far *)inlii;
    funcs[1]=(void far *)checkai;
    funcs[2]=(void far *)plai;
    funcs[3]=(void far *)outchri;
    funcs[4]=(void far *)outstri;
    funcs[5]=(void far *)nli;
    funcs[8]=(void far *)pli;
    funcs[9]=(void far *)emptyi;
    funcs[10]=(void far *)inkeyi;
    funcs[11]=(void far *)getkeyi;
    funcs[12]=(void far *)inputi;
    funcs[13]=(void far *)inputli;
    funcs[14]=(void far *)yni;
    funcs[15]=(void far *)nyi;
    funcs[16]=(void far *)ansici;
    funcs[17]=(void far *)oneki;
    funcs[18]=(void far *)prti;
    funcs[19]=(void far *)mpli;
    setvect(0x6a,(void far interrupt (*) (void))funcs);


    strcpy(ver_no,VERSION_NUMBER);
    strcpy(ver_no1,"BBS=");
    strcat(ver_no1,ver_no);

    getdate(&today);
    if (today.da_year<1988) {
      printf("You need to set the date & time before running the BBS.\n");
      end_bbs(noklevel);
    }
    strcpy(s,"CONFIG.DAT");
    configfile=open(s,O_RDWR | O_BINARY);
    if (configfile<0) {
      printf("%s NOT FOUND.\n",s);
      end_bbs(noklevel);
    }
    read(configfile,(void *) (&syscfg), sizeof(configrec));
    close(configfile);

    if (!syscfg.primaryport)
      ok_modem_stuff=0;

    strcpy(s,syscfg.tempdir);
    i=strlen(s);
    if (s[0]==0)
      i1=1;
    else {
      if ((s[i-1]=='\\') && (s[i-2]!=':'))
        s[i-1]=0;
      i1=chdir(s);
    }
    if (i1) {
      printf("\nYour temporary directory isn't valid.\n");
      printf("It is now set to: '%s'\n\n",syscfg.tempdir);
      end_bbs(noklevel);
    } else
      cd_to(cdir);

    strcpy(s,syscfg.datadir);
    strcat(s,"STATUS.DAT");
    statusfile=open(s,O_RDWR | O_BINARY);
    if (statusfile<0) {
      printf("%s NOT FOUND.\n",s);
      end_bbs(noklevel);
    }
    read(statusfile,(void *)(&status), sizeof(statusrec));
    close(statusfile);
    strcpy(s,VERSION_NUMBER);
    status.wwiv_version=(s[6]-'0')*100+(s[8]-'0')*10+(s[9]-'0');
    smallist=(smalrec *) mallocx((long)syscfg.maxusers * (long)sizeof(smalrec));
    gfilesec=(gfiledirrec *) mallocx((long) (32 * sizeof(gfiledirrec)));

    screensave.scrn1=(char *)mallocx(screenlen);

    read_in_file("MENUS.MSG",(menus),30);
    read_in_file("HELP.MSG",(helps),50);
    for (i=0; i<30; i++) {
      menus1[i].stored_as=0L;
      menus2[i].storage_type=255;
    }
    strcpy(s,syscfg.gfilesdir);
    strcat(s,"MENUSANS.MSG");
    if (exist(s))
      read_in_file("MENUSANS.MSG",(menus1),30);
    strcpy(s,syscfg.gfilesdir);
    strcat(s,"MENUS40.MSG");
    if (exist(s))
      read_in_file("MENUS40.MSG",(menus1),30);

    strcpy(s,syscfg.datadir);
    strcat(s,"GFILE.DAT");
    i=open(s,O_RDWR | O_BINARY);
    if (i<0)
      num_sec=0;
    else
      num_sec=read(i,(void *)gfilesec,32*sizeof(gfiledirrec))/sizeof(gfiledirrec);
    close(i);

    strcpy(s,syscfg.datadir);
    strcat(s,"NAMES.LST");
    i=open(s,O_RDWR | O_BINARY);
    if (i<0) {
      printf("%s NOT FOUND.\n",s);
      end_bbs(noklevel);
    }
    read(i,(void *) (smallist), (sizeof(smalrec) * status.users));
    close(i);

    strcpy(s,syscfg.datadir);
    strcat(s,"SUBS.DAT");
    i=open(s,O_RDWR | O_BINARY);
    if (i<0) {
      printf("%s NOT FOUND.\n",s);
      end_bbs(noklevel);
    }
    num_subs=(read(i,(void *) (&subboards), (32*sizeof(subboardrec))))/
             sizeof(subboardrec);
    close(i);

    strcpy(s,syscfg.datadir);
    strcat(s,"DIRS.DAT");
    i=open(s,O_RDWR | O_BINARY);
    if (i<0) {
      printf("%s NOT FOUND.\n",s);
      end_bbs(noklevel);
    }
    num_dirs=(read(i,(void *) (&directories), (64*sizeof(directoryrec))))/
             sizeof(directoryrec);
    close(i);

    chains=(chainfilerec *) mallocx(50 * sizeof(chainfilerec));
    backuped=editors;
    numextrn=0;
    numchain=0;
    numed=0;
    strcpy(s,syscfg.datadir);
    strcat(s,"CHAINS.DAT");
    i=open(s,O_RDWR | O_BINARY);
    if (i>0) {
      numchain=(read(i,(void *)chains, 50*sizeof(chainfilerec)))/sizeof(chainfilerec);
      numchain=numchain;
      close(i);
    }
    sprintf(s,"%sRESULTS.DAT",syscfg.datadir);
    i=open(s,O_RDWR | O_BINARY);
    if (i>0) {
      l=filelength(i);
      if (l>20*sizeof(resultrec))
        l=20*sizeof(resultrec);
      result_codes=mallocx(l+10);
      num_result_codes=(read(i,result_codes,(unsigned) l))/sizeof(resultrec);
      close(i);
    } else {
      printf("\nRun INIT.EXE to convert result code data.\n\n");
      end_bbs(noklevel);
    }

    sprintf(s,"%sEXTERN.DAT",syscfg.datadir);
    i=open(s,O_RDWR | O_BINARY);
    if (i>0) {
      l=filelength(i);
      if (l>15*sizeof(externalrec))
        l=15*sizeof(externalrec);
      externs=mallocx(l+10);
      numextrn=(read(i,(void *)externs, (unsigned) l))/sizeof(externalrec);
      close(i);
    }
    for (i=0; i<numextrn; i++) {
      checkext[i]=0;
      for (i1=0; i1<81; i1++) {
        checkext[i]+=externs[i].description[i1];
        checkext[i]+=externs[i].sendfn[i1];
        checkext[i]+=externs[i].receivefn[i1];
      }
    }

    sprintf(s,"%sEDITORS.DAT",syscfg.datadir);
    i=open(s,O_RDWR | O_BINARY);
    if (i>0) {
      l=filelength(i);
      if (l>10*sizeof(editorrec))
        l=10*sizeof(editorrec);
      editors=mallocx(l+10);
      numed=(read(i,(void *)editors, (unsigned) l))/sizeof(editorrec);
      numed=numed;
      close(i);
    }
    for (i=0; i<numed; i++) {
      checked[i]=0;
      for (i1=0; i1<81; i1++) {
        checked[i]+=editors[i].filename[i1];
	checked[i]+=editors[i].filenamecon[i1];
      }
    }
    read_user(1,&thisuser);
    if (thisuser.inact & inact_deleted)
      fwaiting=0;
    else
      fwaiting=thisuser.waiting;
    sl1(2,status.date1);
    if (ok_modem_stuff)
      initport(syscfg.primaryport);
    if (syscfg.sysconfig & sysconfig_no_local)
      topdata=0;
    else
      topdata=2;
    ss=getenv("PROMPT");
    strcpy(newprompt,"PROMPT=WWIV: ");
    if (ss)
      strcat(newprompt,ss);
    else
      strcat(newprompt,"$P$G");
    i=0;
    while (environ[i]!=NULL) {
      if (strncmp(environ[i],"PROMPT=",7)==0)
	xenviron[i]=newprompt;
      else
	xenviron[i]=environ[i];
      ++i;
    }
    if (!ss)
      xenviron[i++]=newprompt;
    xenviron[i++]=ver_no1;
    xenviron[i]=NULL;
    for (i=0; i<20; i++)
      questused[i]=0;
    strcpy(s,syscfg.datadir);
    strcat(s,"VOTING.DAT");
    f=open(s,O_RDWR | O_BINARY);
    if (f>0) {
      n=(int) (filelength(f) / sizeof(votingrec)) -1;
      for (i=0; i<n; i++) {
        lseek(f,(long) i * sizeof(votingrec),SEEK_SET);
        read(f,(void *)&v,sizeof(votingrec));
        if (v.numanswers)
	  questused[i]=1;
      }
      close(f);
    }
    if (syscfg.sysconfig & sysconfig_high_speed)
      high_speed=1;
    else
      high_speed=0;
    if (syscfg.sysconfig & sysconfig_flow_control)
      flow_control=1;
    else
      flow_control=0;
    time_event=((double)syscfg.executetime)*60.0;
    last_time=time_event-timer();
    if (last_time<0.0)
      last_time+=24.0*3600.0;
    do_event=0;
    if (status.callernum!=65535) {
      status.callernum1=(long)status.callernum;
      status.callernum=65535;
      save_status();
    }
    msgs=(postrec *) mallocx((long)(255 * sizeof(postrec)));
    read_bbs_list();
    frequent_init();
    if (!restoring_shrink)
      remove_from_temp("*.*",1);
    read_contacts();
    if (!restoring_shrink)
      cleanup_net();
  } else {
    topdata=0;
    ansiptr=0;
    curatr=0x07;
    outcom=0;
    incom=0;
    charbufferpointer=0;
    andwith=0xff;
    checkit=0;
    topline=0;
    endofline[0]=0;
    hangup=0;
    hungup=0;
    chatcall=0;
    chatreason[0]=0;
    useron=0;
    change_color=0;
    chatting=0;
    echo=1;
    lines_listed=0;
    helpl=0;
    ihelp=0;
    using_modem=0;
    thisuser.sysstatus=0;
  }
  lecho=ok_local();
}


void read_user(unsigned int un, userrec *u)
{
  long pos;
  char s[80];
  int i;

  if (userfile==-1) {
    strcpy(s,syscfg.datadir);
    strcat(s,"USER.LST");
    userfile=open(s,O_RDWR | O_BINARY);
    if (userfile<0) {
      u->inact=inact_deleted;
      return;
    }
  }
  if (((useron) && (un==usernum)) || ((wfc) && (un==1))) {
    *u=thisuser;
    if (useron)
      u->sl=realsl;
    return;
  }
  pos=((long) sizeof(userrec)) * ((long) un);
  if (filelength(userfile)<=pos) {
    u->inact=inact_deleted;
    return;
  }
  lseek(userfile,pos,SEEK_SET);
  i=read(userfile, (void *)u, sizeof(userrec));
  if (i==-1) {
    strcpy(s,syscfg.datadir);
    strcat(s,"USER.LST");
    userfile=open(s,O_RDWR | O_BINARY);
    if (userfile<0) {
      u->inact=inact_deleted;
      return;
    }
    pos=((long) sizeof(userrec)) * ((long) un);
    if (filelength(userfile)<=pos) {
      u->inact=inact_deleted;
      return;
    }
    lseek(userfile,pos,SEEK_SET);
    i=read(userfile, (void *)u, sizeof(userrec));
    if (i==-1) {
      pl("COULDN'T READ USER.");
    }
    close_user();
  }
}


void close_user()
{
  if (userfile!=-1) {
    close(userfile);
    userfile=-1;
  }
}


void write_user(unsigned int un, userrec *u)
{
  long pos;
  char s[80];
  unsigned char oldsl;
  int i;

  if (userfile==-1) {
    strcpy(s,syscfg.datadir);
    strcat(s,"USER.LST");
    userfile=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
  }
  if (((useron) && (un==usernum)) || ((wfc) && (un==1))) {
    oldsl=thisuser.sl;
    thisuser=*u;
    if (useron) {
      u->sl=realsl;
      thisuser.sl=oldsl;
    }
  }
  pos=((long) sizeof(userrec)) * ((long) un);
  lseek(userfile,pos,SEEK_SET);
  i=write(userfile, (void *)u, sizeof(userrec));
  if (i==-1) {
    strcpy(s,syscfg.datadir);
    strcat(s,"USER.LST");
    userfile=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
    pos=((long) sizeof(userrec)) * ((long) un);
    lseek(userfile,pos,SEEK_SET);
    i=write(userfile, (void *)u, sizeof(userrec));
    if (i==-1) {
      pl("COULDN'T WRITE USER.");
    }
    close_user();
  }
}


void save_status()
{
  char s[80];

  strcpy(s,syscfg.datadir);
  strcat(s,"STATUS.DAT");
  statusfile=open(s,O_RDWR | O_BINARY);
  write(statusfile, (void *)(&status), sizeof(statusrec));
  close(statusfile);
  statusfile=-1;
}




double ratio()
{
  double r;

  if (thisuser.dk==0)
    return(99.999);
  r=((float) thisuser.uk) / ((float) thisuser.dk);
  if (r>99.998)
    r=99.998;
  return(r);
}


char *nam(userrec *u1, unsigned int un)
{
  static char o[81];
  int i,f,p;
  userrec u;

  u=*u1;
  f=1;
  for (p=0; p<strlen(u.name); p++) {
    if (f) {
      if ((u.name[p]>='A') && (u.name[p]<='Z'))
	f=0;
      o[p]=u.name[p];
    } else {
      if ((u.name[p]>='A') && (u.name[p]<='Z'))
        o[p]=u.name[p]-'A'+'a';
      else {
        if ((u.name[p]>=' ') && (u.name[p]<='/'))
          f=1;
        o[p]=u.name[p];
      }
    }
  }
  o[p++]=32;
  o[p++]='#';
  itoa(un,&o[p],10);
  return(o);
}


char *nam1(userrec *u1, unsigned int un, unsigned int sy)
{
  static char o[81];
  char s[10];

  strcpy(o,nam(u1,un));
  if (sy) {
    strcat(o," @");
    itoa(sy,s,10);
    strcat(o,s);
  }
  return(o);
}

double nsl()
{
  double tlt,tlc,tot,tpl,tpd,dd,rtn;
  slrec xx;

  if (useron) {
    dd=timer();
    if (timeon>dd)
      timeon -= 24.0*3600.0;
    tot=(dd-timeon);
    xx=syscfg.sl[thisuser.sl];
    tpl=((double) xx.time_per_logon) * 60.0;
    tpd=((double) xx.time_per_day) * 60.0;
    tlc = tpl - tot + (thisuser.extratime) + extratimecall;
    tlt = tpd - tot - ((double) thisuser.timeontoday) + (thisuser.extratime);

    tlt=(((tlc)<(tlt)) ? (tlc) : (tlt));
    if (tlt<0.0)
      tlt=0.0;
    if (tlt>32767.0)
      tlt=32767.0;
    rtn=tlt;
  } else {
    rtn=1.00;
  }
  if (syscfg.executetime) {
    tlt=time_event-dd;
    if (tlt<0.0)
      tlt += 24.0*3600.0;
    if (rtn>tlt)
      rtn=tlt;
    check_event();
    if (do_event)
      rtn=0.0;
  }
  if (rtn<0.0)
    rtn=0.0;
  if (rtn>32767.0)
    rtn=32767.0;
  return(rtn);
}


char *date()
{
  static char ds[9];
  struct date today;

  getdate(&today);
  sprintf(ds,"%02d/%02d/%02d",today.da_mon,today.da_day,today.da_year-1900);
  return(ds);
}

char *times()
{
  static char ti[9];
  int h,m,s;
  double t;

  t=timer();
  h=(int) (t/3600.0);
  t-=((double) (h)) * 3600.0;
  m=(int) (t/60.0);
  t-=((double) (m)) * 60.0;
  s=(int) (t);
  sprintf(ti,"%02d:%02d:%02d",h,m,s);
  return(ti);
}


unsigned int finduser(char *s)
{
  int un;
  smalrec *sr;
  userrec u;

  if (strcmp(s,"NEW")==0)
    return(-1);
  if (strcmp(s,"!-@NETWORK@-!")==0)
    return(-2);
  if (strcmp(s,"!-@REMOTE@-!")==0)
    return(-3);

  if ((un=atoi(s))>0) {
    read_user(un,&u);
    if (u.inact & inact_deleted)
      return(0);
    if ((filelength(userfile)/sizeof(userrec))<un)
      return(0);
    return(un);
  }

  sr=(smalrec *) bsearch((void *)s,
			 (void *)smallist,
			 (size_t)status.users,
			 (size_t)sizeof(smalrec),
			 (int _Cdecl (*) (const void *, const void *))strcmp);
  if (sr==0L)
    return(0);
  else {
    read_user(sr->number,&u);
    if (u.inact & inact_deleted)
      return(0);
    else
      return(sr -> number);
  }
}


void changedsl()
{
  int i,i1,i2,i3,i4,ok,dp,ddp;
  subboardrec s;
  directoryrec d;
  usersubrec s1;

  realsl=thisuser.sl;
  topscreen();
  dp=0;
  dc[dp++]='/';
  ddp=0;
  dcd[ddp++]='/';
  for (i=0; i<3; i++) {
    s1.keys[i]=0;
  }
  s1.subnum=-1;
  for (i=0; i<32; i++)
    usub[i]=s1;
  for (i=0; i<64; i++)
    udir[i]=s1;
  i1=1;
  i2=0;
  i3=0;
  for (i=0; i<num_subs; i++) {
    ok=1;
    s=subboards[i];
    if (realsl<s.readsl)
      ok=0;
    if (thisuser.age<s.age)
      ok=0;
    if ((s.ar!=0) && (((thisuser.ar) & (s.ar))==0))
      ok=0;
    if (ok) {
      s1.subnum=i;
      if (s.key!=0) {
        s1.keys[0]=s.key;
        s1.keys[1]=0;
        s1.subnum=i;
        usub[i3++]=s1;
      } else {
        if ((i1 % 10)==0)
          dc[dp++]=('0'+(i1/10));
        itoa(i1++,s1.keys,10);
        s1.subnum=i;
        for (i4=i3; i4>i2; i4--)
          usub[i4]=usub[i4-1];
        i3++;
        usub[i2++]=s1;
      }
    }
  }
  i1=1;
  i2=0;
  for (i=0; i<num_dirs; i++) {
    ok=1;
    d=directories[i];
    if (thisuser.dsl<d.dsl)
      ok=0;
    if (thisuser.age<d.age)
      ok=0;
    if (d.dar)
      if ((d.dar & thisuser.dar)==0)
        ok=0;
    if (ok) {
      s1.subnum=i;
      if (i==0)
        strcpy(s1.keys,"0");
      else {
        if ((i1 % 10)==0)
          dcd[ddp++]=('0'+(i1/10));
        itoa(i1++,s1.keys,10);
      }
      udir[i2++]=s1;
    }
  }
  dcd[ddp]=0;
  dc[dp]=0;
}


void isr(int un, char *name)
{
  int cp,i;
  char s[81];
  smalrec sr;

  cp=0;
  while ((cp<status.users) && (strcmp(name,(smallist[cp].name))>0))
    ++cp;
  memmove(&(smallist[cp+1]),&(smallist[cp]),sizeof(smalrec)*(status.users-cp));
  strcpy(sr.name,name);
  sr.number=un;
  smallist[cp]=sr;
  strcpy(s,syscfg.datadir);
  strcat(s,"NAMES.LST");
  i=open(s,O_RDWR | O_BINARY | O_TRUNC);
  if (i<0) {
    printf("%s NOT FOUND.\n",s);
    end_bbs(noklevel);
  }
  ++status.users;
  save_status();
  write(i,(void *) (smallist), (sizeof(smalrec) * status.users));
  close(i);
}


void dsr(char *name)
{
  int cp,i;
  char s[81];
  smalrec sr;

  cp=0;
  while ((cp<status.users) && (strcmp(name,(smallist[cp].name))!=0))
    ++cp;
  if (strcmp(name,(smallist[cp].name))) {
    strcpy(s,name);
    strcat(s," NOT ABLE TO BE DELETED#*#*#*#*#*#*#*#");
    sl1(0,s);
    sl1(0,"#*#*#*# Run //resetf to fix it");
    return;
  }
  memmove(&(smallist[cp]),&(smallist[cp+1]),sizeof(smalrec)*(status.users-cp));
  strcpy(s,syscfg.datadir);
  strcat(s,"NAMES.LST");
  i=open(s,O_RDWR | O_BINARY | O_TRUNC | O_CREAT, S_IREAD | S_IWRITE);
  if (i<0) {
    printf("%s COULN'T BE CREATED.\n",s);
    end_bbs(noklevel);
  }
  --status.users;
  save_status();
  write(i,(void *) (smallist), (sizeof(smalrec) * status.users));
  close(i);
}


void wait(double d)
{
  long l1;

  l1=((long) (18.2*d));
  l1 += timer1();

  enable();
  while (timer1()<l1)
    ;
}

void wait1(long l)
{
  long l1;

  l1 = timer1()+l;

  enable();
  while (timer1()<l1)
    ;
}


double freek1(char *s)
{
  int d;

  d=cdir[0];
  if (s[1]==':')
    d=s[0];
  d=d-'A'+1;
  return(freek(d));
}


int exist(char *s)
{
  int f;

  f=open(s,O_RDONLY | O_BINARY);
  close(f);
  if (f>0)
    return(1);
  else
    return(0);
}


void add_ass(int i, char *ss)
{
  char s[81],s1[10];

  strcpy(s,"*** ");
  sysoplog(s);
  strcat(s,ss);
  sysoplog(s);
  itoa(i,s1,10);
  strcpy(s,"*** ASS-PTS: ");
  strcat(s,s1);
  sysoplog(s);
  thisuser.ass_pts += i;
}
