#include <sys\stat.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <alloc.h>
#include "vardec.h"
#include "fcns.h"


extern int hangup,checkit,okmacro,two_color,lastcon,using_modem,live_user;
extern char dc[81],dcd[81],odc[81];
extern char charbuffer[161];
extern userrec thisuser;
extern int charbufferpointer,chatting;
extern int usernum,useron,num_sec,helpl;
extern configrec syscfg;
extern int echo;
extern unsigned char realsl;
extern double timeon,extratimecall;
extern char curspeed[80];
extern int cursub,curdir,curdloads,use_workspace,global_xx;
extern usersubrec usub[32],udir[32];
extern statusrec status;
extern int incom,outcom,msgreadlogon;
extern int fsenttoday,userfile,chatcall,mailcheck,smwcheck;
extern char chatreason[81],irt[81];
extern subboardrec subboards[32];
extern long nscandate;
extern float batchtime;
extern int numbatch, numbatchul, numed;
extern editorrec *editors;
extern gfiledirrec *gfilesec;
extern char xdate[9];
extern int questused[20];
extern unsigned int modem_speed,com_speed;
extern char ctypes[NUM_CTYPES][18];
extern int nodenum;


void far *malloca(unsigned long nbytes)
{
  void *buf;
  char x[81];

  buf=farmalloc(nbytes+1);
  if (buf==NULL) {
    nl();
    ltoa(nbytes,x,10);
    print("Not enough memory, needed ",x," bytes","");
    nl();
    sysoplog("!!! Ran out of memory !!!");
  }
  return(buf);
}



void stuff_in(char *s, char *s1, char *f1, char *f2, char *f3, char *f4, char *f5)
{
  int r=0,w=0;

  while (s1[r]!=0) {
    if (s1[r]=='%') {
      ++r;
      s[w]=0;
      switch(s1[r]) {
        case '1': strcat(s,f1); break;
        case '2': strcat(s,f2); break;
        case '3': strcat(s,f3); break;
        case '4': strcat(s,f4); break;
        case '5': strcat(s,f5); break;
      }
      w=strlen(s);
      r++;
    } else
      s[w++]=s1[r++];
  }
  s[w]=0;
}

void copy_line(char *s, char *b, long *ptr, long len)
{
  int i;
  long l;

  if (*ptr>=len) {
    s[0]=0;
    return;
  }
  l=*ptr;
  i=0;
  while ((b[l]!='\r') && (b[l]!='\n') && (l<len)) {
    s[i++]=b[l++];
  }
  s[i]=0;
  if ((b[l]=='\r') && (l<len))
    ++l;
  if ((b[l]=='\n') && (l<len))
    ++l;
  *ptr=l;
}

char *get_file(char *fn, long *len)
{
  int i;
  char *s;

  i=nopen(fn,0);
  if (i<0) {
    *len=0L;
    return(NULL);
  }
  if ((s=malloca(filelength(i)+50))==NULL) {
    *len=0L;
    close(i);
    return(NULL);
  }
  *len=(long) read(i,(void *)s, filelength(i));
  close(i);
  return(s);
}


gfilerec *read_sec(int sn, int *nf)
{
  gfilerec *g;
  int f,i;
  char s[81];

  i=sizeof(gfilerec)*(gfilesec[sn].maxfiles);
  if ((g=malloca((long) i))==NULL) {
    *nf=0;
   return(NULL);
  }
  sprintf(s,"%s%s.GFL",syscfg.datadir,gfilesec[sn].filename);
  f=nopen(s,0);
  if (f==-1)
    *nf=0;
  else
    *nf=read(f,(void *)g,i)/sizeof(gfilerec);
  close(f);
  return(g);
}


void list_sec(int *map, int nmap)
{
  int i,abort;
  char s[81];

  abort=0;
  pla("",&abort);
  pla("",&abort);
  pla("G-Files sections available:",&abort);
  pla("",&abort);
  for (i=0; (i<nmap) && (!abort) && (!hangup); i++) {
    s[0]=32;
    if (i<=8)
      itoa(i+1,&(s[1]),10);
    else
      itoa(i+1,s,10);
    strcat(s,". ");
    strcat(s,gfilesec[map[i]].name);
    pla(s,&abort);
  }
  nl();
}


void list_gfiles(gfilerec *g, int nf)
{
  int i,abort;
  char s[81];

  abort=0;
  pla("",&abort);
  pla("",&abort);
  pla("G-Files in this section:",&abort);
  pla("",&abort);
  if ((nf==0) && (abort==0)) {
    nl();
    pl("None.");
    nl();
  }
  for (i=0; (i<nf) && (!abort) && (!hangup); i++) {
    s[0]=32;
    if (i<=8)
      itoa(i+1,&(s[1]),10);
    else
      itoa(i+1,s,10);
    strcat(s,". ");
    strcat(s,g[i].description);
    pla(s,&abort);
  }
  nl();
  if ((!abort) && (cs())) {
    pl("A. Add G-files");
    pl("D. Delete G-files");
    nl();
  }
}


void gfile_sec(int sn)
{
  gfilerec *g;
  int i,done,nf,i1;
  char xdc[81],*ss,*ss1,s[81];

  g=read_sec(sn,&nf);
  if (g==NULL)
    return;
  strcpy(xdc,odc);
  for (i=0; i<20; i++)
    odc[i]=0;
  for (i=1; i<=nf/10; i++)
    odc[i-1]=i+'0';
  list_gfiles(g,nf);
  done=0;
  while ((!done) && (!hangup)) {
    nl();
    tleft(1);
    prt(2,"Which G-file (Q=Quit) ? ");
    ss=mmkey(2);
    i=atoi(ss);
    if (strcmp(ss,"Q")==0)
      done=1;
    else
      if ((strcmp(ss,"A")==0) && (cs())) {
	farfree(g);
	fill_sec(sn);
        g=read_sec(sn,&nf);
        if (g==NULL)
          return;
        for (i=0; i<20; i++)
          odc[i]=0;
        for (i=1; i<=nf/10; i++)
          odc[i-1]=i+'0';
      } else
	if ((strcmp(ss,"D")==0) && (cs())) {
	  nl();
	  prt(2,"G-file number to delete? ");
          ss1=mmkey(2);
	  i=atoi(ss1);
	  if ((i>0) && (i<=nf)) {
            sprintf(s,"Remove %s? ",g[i-1].description);
	    prt(5,s);
	    if (yn()) {
	      prt(5,"Erase file too? ");
	      if (yn()) {
                sprintf(s,"%s%s\\%s",syscfg.gfilesdir,
                      gfilesec[sn].filename,g[i-1].filename);
		unlink(s);
	      }
              for (i1=i; i1<nf; i1++)
		g[i1-1]=g[i1];
	      --nf;
              sprintf(s,"%s%s.GFL",syscfg.datadir,gfilesec[sn].filename);
	      i=nopen(s,3);
              write(i,(void *)g,nf*sizeof(gfilerec));
              close(i);
              nl();
	      pl("Deleted.");
	      nl();
	    }
	  }
	} else
          if (strcmp(ss,"?")==0)
	    list_gfiles(g,nf);
	  else
            if ((i>0) && (i<=nf)) {
              sprintf(s,"%s\\%s",gfilesec[sn].filename,g[i-1].filename);
	      i1=printfile(s);
	      if (i1==0) {
                sprintf(s,"Read G-file '%s'",g[i-1].filename);
	        sysoplog(s);
	      }
            }
  }
  farfree(g);
  strcpy(odc,xdc);
}


void gfiles()
{
  int i,i1,i2,done,abort,map[32],nmap,ok;
  char s[81],s1[81],s2[81],*ss;

  done=0;
  nmap=0;
  for (i=0; i<20; i++)
    odc[i]=0;
  for (i=0; i<num_sec; i++) {
    ok=1;
    if (thisuser.age<gfilesec[i].age)
      ok=0;
    if (thisuser.sl<gfilesec[i].sl)
      ok=0;
    if (((thisuser.ar & gfilesec[i].ar)==0) && (gfilesec[i].ar))
      ok=0;
    if (ok) {
      map[nmap++]=i;
      if ((nmap % 10)==0)
	odc[nmap/10-1]='0'+(nmap/10);
    }
  }
  if (nmap==0) {
    nl();
    pl("No G-file sections available.");
    nl();
    return;
  }
  list_sec(map,nmap);
  while ((!done) && (!hangup)) {
    nl();
    tleft(1);
    prt(2,"Which section (Q=Quit) ? ");
    ss=mmkey(2);
    if (strcmp(ss,"Q")==0)
      done=1;
    else
      if (strcmp(ss,"?")==0)
	list_sec(map,nmap);
      else
	if ((strcmp(ss,"A")==0) && (cs())) {
	  i1=0;
	  for (i=0; (i<nmap) && (!i1); i++) {
	    nl();
	    print("Now loading files for ",gfilesec[map[i]].name,"");
	    nl();
	    i1=fill_sec(map[i]);
	  }
	} else {
          i=atoi(ss);
          if ((i>0) && (i<=nmap)) {
	    gfile_sec(map[i-1]);
          }
        }
  }
}


void mailr()
{
  int i,abort,a,f,next;
  mailrec m;
  char c,s[81];
  userrec u;

  strcpy(s,syscfg.datadir);
  strcat(s,"EMAIL.DAT");
  f=nopen(s,6);
  if (f!=-1) {
    i=filelength(f)/sizeof(mailrec)-1;
    c=' ';
    while ((i>=0) && (c!='Q') && (!hangup)) {
      lseek(f,((long) (i)) * ((long) sizeof(mailrec)),SEEK_SET);
      read(f,(void *)&m,sizeof(mailrec));
      if (m.touser!=0) {
        do {
          if (m.tosys!=0) {
	    outstr("To   : System #");
	    itoa(m.tosys,s,10);
	    pl(s);
	  } else {
	    read_user(m.touser,&u);
	    print("To   : ",nam(&u,m.touser),"");
	  }
          print("Title: ",m.title,"");
          setorigin(m.fromsys);
          read_message1(&(m.msg),m.anony & 0x0f,1,&next,"EMAIL");
	  prt(2,"R,D,P,Q,<space>  : ");
          if (next)
	    c=' ';                 /* Purge User m0d - MAILR */
	  else
	    c=onek("QRDP ");
          if (c=='D') {
            delmail(f,i);
	    if ((!useron) && (m.touser==1) && (m.tosys==0))
	      --thisuser.waiting;
	  }
	  if (c=='P') {
	    read_user(m.fromuser,&u);
	    sprintf(s,"Purge %s (Y/N)? ",nam(&u,m.fromuser));
	    prt(2,s);
	    if (yn()) {
		deluser(m.fromuser);
		sprintf(s,"%s Deleted!\n",nam(&u,m.fromuser));
		prt(6,s); } }
          nl();
	  nl();
        } while ((c=='R') && (!hangup));
      }
      i-=1;
    }
    close(f);
    close_user();
  }
}


void chuser()
{
  char s[81];
  int i;

  if (!checkpw())
    return;
  if (!so())
    return;
  prt(2,"User to change to? ");
  input(s,30);
  i=finduser1(s);
  if (i>0) {
    thisuser.sl=realsl;
    write_user(usernum,&thisuser);
    read_user(i,&thisuser);
    usernum=i;
    close_user();
    realsl=thisuser.sl;
    thisuser.sl=255;
    strcpy(s,"#*#*#* Changed to ");
    strcat(s,nam(&thisuser,usernum));
    topscreen();
    sysoplog(s);
  } else
    pl("Unknown user.");
}

char *mmkey(int dl)
{
  static unsigned char cmd1[10],cmd2[81],ch;
  int i,i1,i2,p;

  do {
    do {
      ch=getkey();
    } while ((((ch<' ') && (ch!=13)) || (ch>126)) && (hangup==0));
    ch=upcase(ch);
    outchr(ch);
    if (ch==13)
      cmd1[0]=0;
    else
      cmd1[0]=ch;
    cmd1[1]=0;
    p=0;
    switch(dl) {

    case 1:
      if (strchr(dcd,ch)!=NULL)
        p=1;
      break;
    case 2:
      if (strchr(odc,ch)!=NULL)
        p=1;
      break;
    case 0:
      if (strchr(dc,ch)!=NULL)
        p=1;
      break;
    }
    if (p) {
      do {
        ch=getkey();
      } while ((((ch<' ') && (ch!=13) && (ch!=8)) || (ch>126)) && (hangup==0));
      ch=upcase(ch);
      if (ch==13) {
        nl();
        return(cmd1);
      } else
        if (ch==8) {
          backspace();
        } else {
          cmd1[1]=ch;
          cmd1[2]=0;
          outchr(ch);
          if (ch=='/') {
            input(cmd2,50);
            return(cmd2);
          } else
            nl();
            return(cmd1);
        }
    } else {
      nl();
      return(cmd1);
    }
  } while (hangup==0);
  cmd1[0]=0;
  return(cmd1);
}


void inli(char *s, char *rollover, int maxlen, int crend)
{
  int cp,i,i1,done,cm,begx;
  char s1[255];
  unsigned char ch;

  cm=chatting;

  begx=wherex();
  if (rollover[0]!=0) {
    if (charbufferpointer) {
      strcpy(s1,rollover);
      strcat(s1,&charbuffer[charbufferpointer]);
      strcpy(&charbuffer[1],s1);
      charbufferpointer=1;
    } else {
      strcpy(&charbuffer[1],rollover);
      charbufferpointer=1;
    }
    rollover[0]=0;
  }
  cp=0;
  done=0;
  do {
    ch=getkey();
    if (two_color)
      if (lastcon)
	ansic(1);
      else
	ansic(0);
    if (cm)
      if (chatting==0)
        ch=13;
    if ((ch>=32)) {
      if ((wherex()<(thisuser.screenchars-1)) && (cp<maxlen)) {
        s[cp++]=ch;
        outchr(ch);
        if (wherex()==(thisuser.screenchars-1))
          done=1;
      } else {
        if (wherex()>=(thisuser.screenchars-1))
          done=1;
      }
    } else
        switch(ch) {
	  case 7:
	    if ((chatting) && (outcom))
	      outcomch(7);
	    break;
          case 13: /* C/R */
            s[cp]=0;
            done=1;
            break;
          case 8:  /* Backspace */
            if (cp) {
              if (s[cp-2]==3) {
                cp-=2;
                ansic(0);
              } else
                if (s[cp-1]==8) {
                  cp--;
                  outchr(32);
                } else {
                  cp--;
                  backspace();
                }
            }
            break;
          case 24: /* Ctrl-X */
            while (wherex()>begx) {
              backspace();
              cp=0;
            }
            ansic(0);
            break;
          case 23: /* Ctrl-W */
            if (cp) {
              do {
                if (s[cp-2]==3) {
                  cp-=2;
                  ansic(0);
                } else
                  if (s[cp-1]==8) {
                    cp--;
                    outchr(32);
                  } else {
                    cp--;
                    backspace();
                  }
              } while ((cp) && (s[cp-1]!=32) && (s[cp-1]!=8) && (s[cp-2]!=3));
            }
            break;
          case 14: /* Ctrl-N */
            if ((wherex()) && (cp<maxlen)) {
              outchr(8);
              s[cp++]=8;
            }
            break;
          case 16: /* Ctrl-P */
            if (cp<maxlen-1) {
              ch=getkey();
	      if ((ch>='0') && (ch<='7')) {
                s[cp++]=3;
                s[cp++]=ch;
                ansic(ch-'0');
              }
            }
            break;
          case 9:  /* Tab */
            i=5-(cp % 5);
            if (((cp+i)<maxlen) && ((wherex()+i)<thisuser.screenchars)) {
	      i=5-((wherex()+1) % 5);
              for (i1=0; i1<i; i1++) {
                s[cp++]=32;
                outchr(32);
              }
            }
            break;
        }
  } while ((done==0) && (hangup==0));
  if (ch!=13) {
    i=cp-1;
    while ((i>0) && (s[i]!=32) && (s[i]!=8) || (s[i-1]==3))
      i--;
    if ((i>(wherex()/2)) && (i!=(cp-1))) {
      i1=cp-i-1;
      for (i=0; i<i1; i++)
        outchr(8);
      for (i=0; i<i1; i++)
        outchr(32);
      for (i=0; i<i1; i++)
        rollover[i]=s[cp-i1+i];
      rollover[i1]=0;
      cp -= i1;
    }
    s[cp++]=1;
    s[cp]=0;
  }
  if (crend)
    nl();

}


void getuser()
{
  char s[81],s2[81];
  int ok,count,net_only;
  long l;

  thisuser.sysstatus &= (~sysstatus_ansi);
  net_only=1;
  if (syscfg.netlowtime!= syscfg.nethightime) {
    if (syscfg.nethightime>syscfg.netlowtime) {
      if ((timer()<=(syscfg.netlowtime*60.0)) || (timer()>=(syscfg.nethightime*60.0)))
        net_only=0;
    } else {
      if ((timer()<=(syscfg.netlowtime*60.0)) && (timer()>=(syscfg.nethightime*60.0)))
        net_only=0;
    }
  } else
    net_only=0;
  count=0;
  ok=0;
  checkit=1;
  okmacro=0;
  if ((!net_only) && (incom)) {
    strcpy(s,syscfg.gfilesdir);
    strcat(s,"welcome.ans");
    if (exist(s)) {
      nl();
      outstr("Can you support ANSI graphics? ");
      thisuser.sysstatus=0;
      if (yn())
	printfile("welcome.ans");
      else
	printfile("welcome.msg");
    } else
      printfile("welcome.msg");
   strcpy(s,syscfg.gfilesdir);
   strcat(s,"welcome2.msg");
   if (exist(s))
       printfile("welcome2.msg");
  }
  ansic(0);
  do {
    nl();
    if (net_only) {
      pl("This time is reserved for net-mail ONLY.");
      pl("Please try calling back again later.");
    } else
      pl("Enter number or name or 'NEW'");
    outstr("NN: "); /* DON'T change the NN: prompt. */
    input(s,30);
    usernum=finduser(s);
    if ((net_only) && (usernum!=-2))
      usernum=0;
    if (usernum>0) {
      read_user(usernum,&thisuser);
      realsl=thisuser.sl;
      topscreen();
      ok=1;
      outstr("PW: ");
      echo=0;
      input(s,8);
      strcpy(s2," PW: ");                  /* Illegal Logon m0d */
      strcat(s2,s);
      strcat(s2,"    PH: ###-###-");
      if (strcmp(s,thisuser.pw)!=0)
        ok=0;
      outstr("PH: ###-###-");
      echo=0;
      input(s,4);
      if (strcmp(s,&thisuser.phone[8])!=0) {
        ok=0;
        if ((strlen(s)==4) && (s[3]=='-')) {
          nl();
          pl("!! Enter the LAST 4 DIGITS of your phone number ONLY !!");
          nl();
        }
      }
      strcat(s2,s);
      if ((thisuser.sl==255) && (incom) && (ok)) {
        outstr("SY: ");
        echo=0;
        input(s,20);
        if (strcmp(s,syscfg.systempw)!=0)
	  ok=0;
      }
       thisuser.bwcolors[7]=123;
      echo=1;
      if (ok) {
        changedsl();
      } else {
        ++thisuser.illegal;
        write_user(usernum,&thisuser);
        close_user();
        nl();
        pl("\7ILLEGAL LOGON\7");
	nl();
	printfile("ILLEGAL.MSG");           /* Illegal logon message m0d */
        strcpy(s,"### ILLEGAL LOGON for ");
	strcat(s,nam(&thisuser,usernum));
	strcat(s,s2);
	sl1(0,s);
	strcpy(s,"    Should have been: ");
	strcat(s,nam(&thisuser,usernum));
	strcat(s," PW: ");
	strcat(s,thisuser.pw);
	strcat(s,"    PH: ");
	strcat(s,thisuser.phone);
	strcat(s,"\n");
	sl1(0,s);
	usernum=0;
      }
    } else
      if (usernum==-1) {
        newuser();
        ok=1;
      } else
        if (usernum==0) {
	  if (net_only)
	    nl();
	  else
            pl("Unknown User.");
        } else
	  if (usernum==-2) {
	    if (incom) {
              time(&l);
              sprintf(s,"NETWORK /B%u /T%ld",modem_speed,l);
              save_status();
              run_external1(s);
              get_status();
              hangup=1;
              dtr(0);
              global_xx=0;
              wait(1.0);
              dtr(1);
              wait(0.1);
	      cleanup_net();
	      imodem();
	    }
	    hangup=1;
          } else
            if (usernum==-3) {
              if (incom)
                function_remotely();
              hangup=1;
              dtr(0);
            }
  } while ((!hangup) && (!ok) && (++count<3));
  if (count==3)
    hangup=1;
  checkit=0;
  okmacro=1;
  if ((!hangup) && (usernum>0) && (thisuser.restrict & restrict_logon) &&
    (strcmp(date(),thisuser.laston)==0) && (thisuser.ontoday>0)) {
    nl();
    pl("Sorry, you can only logon once per day.");
    nl();
    hangup=1;
  }
}


void beginday()
{
  char s[81];
  zlogrec z,z1;
  int f,i,i1;

  strcpy(z.date,status.date1);
  z.active=status.activetoday;
  z.calls=status.callstoday;
  z.posts=status.msgposttoday;
  z.email=status.emailtoday;
  z.fback=status.fbacktoday;
  z.up=status.uptoday;
  status.callstoday=0;
  status.msgposttoday=0;
  status.emailtoday=0;
  status.fbacktoday=0;
  status.uptoday=0;
  status.activetoday=0;
  strcpy(status.date3,status.date2);
  strcpy(status.date2,status.date1);
  strcpy(status.date1,date());
  strcpy(status.log2,status.log1);
  sl1(3,status.log1);
  sl1(2,date());
  if (1) {
    strcpy(s,syscfg.gfilesdir);
    strcat(s,status.log2);
    unlink(s);
  }
  strcpy(s,syscfg.gfilesdir);
  strcat(s,"USER.LOG");
  unlink(s);
  save_status();
  strcpy(s,syscfg.datadir);
  strcat(s,"ZLOG.DAT");
  f=nopen(s,1);
  if (f<0) {
    f=nopen(s,2);
    z1.date[0]=0;
    z1.active=0;
    z1.calls=0;
    z1.posts=0;
    z1.email=0;
    z1.fback=0;
    z1.up=0;
    for (i=0; i<97; i++)
      write(f,(void *)&z1,sizeof(zlogrec));
  } else {
    for (i=96; i>=1; i--) {
      lseek(f,(long) ((i-1) * sizeof(zlogrec)),SEEK_SET);
      read(f,(void *)&z1,sizeof(zlogrec));
      lseek(f,(long) (i * sizeof(zlogrec)),SEEK_SET);
      write(f,(void *)&z1,sizeof(zlogrec));
    }
  }
  lseek(f,0L,SEEK_SET);
  write(f,(void *)&z,sizeof(zlogrec));
  close(f);
  if (syscfg.beginday_c[0]) {
    stuff_in(s,syscfg.beginday_c,create_chain_file("CHAIN.TXT"),"","","","");
    full_external(s,0,1);
  }
}


void logon()
{
  char s[81],s1[81],s2[81],*ss;
  int i,i1,f,done;
  long len,pos;

      if (thisuser.sl<10){   /* Immeditate New User Logoff m0d */
	nl();
	pl("You're not validated yet. Call back later.");
	nl(); nl(); nl();
	delay(2000);
	hangup=1;
	dtr(0);
	return;}



  if (live_user) {
    ansic(0);
    outchr(12);
  }
  if (strcmp(date(),status.date1)!=0) {
    if (live_user) {
      nl();
      pl("Now doing daily maintenance.");
      nl();
    }
    beginday();
  }
  if (incom && live_user) {	/* Forced Logon Message m0d */
   incom=0;
   printfile("LOGON");
   incom=1;
   dump();
   pausescr();
  }



  if (strcmp(date(),thisuser.laston)==0)
    ++thisuser.ontoday;
  else {
    thisuser.ontoday=1;
    thisuser.timeontoday=0.0;
    thisuser.extratime=0.0;
    thisuser.posttoday=0;
    thisuser.etoday=0;
    thisuser.fsenttoday1=0;
  }
  ++thisuser.logons;
  cursub=0;
  msgreadlogon=0;
  if (udir[0].subnum==0)
    curdir=1;
  else
    curdir=0;
  curdloads=0;
  sprintf(s,"%sONLINE%d.DAT",syscfg.datadir,nodenum);
  remove(s); /* Remove User flag m0d < - shouldn't be there */
  sprintf(s,"%sNETCHAT%d.PAG",syscfg.datadir,nodenum);
  remove(s); /* Remove page flag m0d < - shouldn't be there */
  get_status(); /* Read Status into Memory Function m0d */

  if (!so()) {
    ++status.callernum1;
    ++status.callstoday;
    save_status();             /* Close status.dat */
  }
  sprintf(s,"%ld: %s %s %s   %s - %d",
       status.callernum1,
       nam(&thisuser,usernum),
       times(),
       date(),
       curspeed,
       thisuser.ontoday);


  strcpy(s2,syscfg.gfilesdir);
  strcat(s2,"LASTON.TXT");
  ss=get_file(s2,&len);
  pos=0;
  if (ss!=NULL) {
    if (!cs())
      for (i=0; i<4; i++)
	copy_line(s1,ss,&pos,len);
    i=1;
    do {
      copy_line(s1,ss,&pos,len);
      if ((s1[0]) && live_user) {
	if (i) {
	  i=0;
       /* nl();
	  nl();*/
	  pl("Last few callers: ");
	  nl();
	}
	pl(s1);
      }
    } while (pos<len);
  }
  if ((thisuser.sl!=255) || (incom)) {
    sl1(0,"");
    sl1(0,s);                /* Caller Log m0d */
    sl1(1,"");
    sprintf(s,"%ld-%d: %-35.35s %-21.21s   %s-%d"
    ,status.callernum1,nodenum,nam(&thisuser,usernum),thisuser.note
    ,curspeed,thisuser.ontoday);
    strcpy(s1,syscfg.gfilesdir);
    strcat(s1,"USER.LOG");
    f=nopen(s1,2);
    lseek(f,0L,SEEK_END);
    i=strlen(s);
    s[i++]='\r';
    s[i++]='\n';
    s[i]=0;
    if (thisuser.sl!=255) {
      write(f,(void *)s,i);
      close(f);
      f=nopen(s2,3);
      pos=0;
      copy_line(s1,ss,&pos,len);
      for (i=1; i<8; i++) {
        copy_line(s1,ss,&pos,len);
        strcat(s1,"\r\n");
        write(f,(void *)s1,strlen(s1));
      }
      write(f,(void *)s,strlen(s));
      close(f);
    } else
      close(f);
  }

  if (ss!=NULL)
    farfree(ss);

  if (live_user)
    read_automessage();
  timeon=timer();
  useron=1;
  if (live_user)
    topscreen();

  if ((syscfg.logon_c[0]) && live_user) {
    nl();
    strcpy(s1,syscfg.logon_c);
    strcpy(s2,create_chain_file("CHAIN.TXT"));
    stuff_in(s,s1,s2,"","","","");
    full_external(s,0,1);
    nl();
    nl();
   }


  if (live_user) {
/*   nl();  */
    usertest(); /* User test mod */
    print("Name           : ",nam(&thisuser,usernum),"");
    i=(int)((nsl()+30)/60.0);
    itoa(i,s,10);
    print("Time allowed on: ",s,"");
    if (thisuser.illegal) {
      itoa(thisuser.illegal,s,10);
      print("Illegal logons : ",s,"");
    }
    itoa(thisuser.waiting,s,10);
    if (thisuser.waiting)
      print("Mail waiting   : ",s,"");
    itoa(thisuser.ontoday,s,10);
    if (thisuser.ontoday==1)
      print("Last on        : ",thisuser.laston,"");
    else
      print("Times on today : ",s,"");
    if (sysop2())
      pl("Sysop is       : Watching");      /* Sysop Status m0d */
    else {
      strcpy(s,"Sysop is       : ");
    i=rand() % 16;
    switch(i){
	 case 1:
	    strcat(s,"Eating ice cream");
	    break;
	 case 2:
	    strcat(s,"Listening to Rush");
	    break;
	 case 3:
	    strcat(s,"Programming in 'C");
	    break;
	 case 4:
	    strcat(s,"Asleep");
	    break;
	 case 5:
	    strcat(s,"In the restroom");
	    break;
	 case 6:
	    strcat(s,"Taking a shower");
	    break;
	 case 7:
	    strcat(s,"Listening to Metallica");
	    break;
	 case 8:
	    strcat(s,"Playing the drums");
	    break;
	 case 9:
	    strcat(s,"Tinkering with the File Server");
	    break;
	 case 10:
	    strcat(s,"Eating Budget Gourmet");
	    break;
	 case 11:
	    strcat(s,"On Another Line");
	    break;
	 case 12:
	    strcat(s,"Meditating");
	    break;
	 case 13:
	    strcat(s,"Cleaning his AK-47");
	    break;
	 case 14:
	    strcat(s,"Experimenting with Chemicals");
	    break;
	 case 15:
	    strcat(s,"Blowing his Nose");
	    break;
	 case 16:
	    strcat(s,"Trying to Sleep");
	    break;
	 default:
	    strcat(s,"Laughing at Quiz Responses");
	    break;
	 }
       pl(s);
       }

/*  if (syscfg.wwiv_reg_number)
      sprintf(s,"(Reg #%ld)",syscfg.wwiv_reg_number);
    else
      strcpy(s,"(Unregistered)");
    sprintf(s1,"System is      : %s   ",VERSION_NUMBER);
    pl(s1);                       */
/****************************************************************************/

    if (syscfg.systemnumber) {
      itoa(syscfg.systemnumber,s,10);
      print("DOVE-Net node  : ",s,"");      /* WWIV-Net to DOVE-Net m0d */
    }
    if (nodenum){
    sprintf(s,"Vertrauen node : %d",nodenum);
    pl(s);
    nodecheck(); /* Create Node-User Flag File m0d */
    sprintf(s,"%sONLINE%d.DAT",syscfg.datadir,nodenum);
    f=nopen(s,2);
    sprintf(s,"%s is currently on node %d",nam(&thisuser,usernum),nodenum);
    if(incom && live_user){
      sprintf(s1," at %dbps.\r",modem_speed);
      strcat(s,s1);
      }
    else
      strcat(s," locally.\r");
    write(f,(void *)s,strlen(s));
    close(f);}
    if (thisuser.forwardusr) {
      nl();
      if (thisuser.forwardsys)
        sprintf(s1,"Forwarding mail to #%d @%d.",
            thisuser.forwardusr,thisuser.forwardsys);
      else
        sprintf(s1,"Forwarding mail to user #%d.",thisuser.forwardusr);
      pl(s1);
      nl();
    }
    fsenttoday=0;


    if (thisuser.year) {
      s[0]=years_old(thisuser.month,thisuser.day,thisuser.year);
      if (thisuser.age!=s[0]) {
        thisuser.age=s[0];
        topscreen();
      }
    } else {
      nl();
      pl("Please enter the following information:");
      do {
        nl();
        input_age(&thisuser);
        sprintf(s,"%02d/%02d/%02d",(int) thisuser.month,
                                (int) thisuser.day,
                                (int) thisuser.year);
        nl();
        prompt("Birthdate: ",s,".  Correct? ","");
        if (!yn())
          thisuser.year=0;
      } while ((!hangup) && (thisuser.year==0));
      topscreen();
      nl();
    }

    rsm(usernum,&thisuser);
    if (thisuser.waiting) {
      nl();
      prt(5,"Read your mail now? ");
      if (yn())
        readmail();
    }
  }
  nscandate=thisuser.daten;
  batchtime=0.0;
  numbatch=0;
  numbatchul=0;
  strcpy(xdate,date());
  i1=0;
  for (i=0; i<20; i++) {
    if (questused[i])
      if (thisuser.votes[i]==0)
	i1=1;
  }
  if (restrict_vote & thisuser.restrict)
    i1=0;
  if (thisuser.sl<=10)
    i1=0;
  if (i1 && live_user) {
    nl();
    prt(3,"You haven't voted yet.");
    nl();
    nl();
  }

    if ((thisuser.sysstatus & sysstatus_expert)==0){
       thisuser.sysstatus ^= sysstatus_expert;
       nl();                                 /* Forced Expert Mode m0d */
       pl("      Hit '?' to view a menu of"
	 " available commands at any time! ");
    }
}


void logoff()
{
  long l;
  int f,r,w,t;
  char s[81];
  mailrec m;
  shortmsgrec sm;
  double ton;

  dtr(0);
  hangup=1;
  if(modem_speed)
    thisuser.lastrate=modem_speed;
  strcpy(thisuser.laston,xdate);
  thisuser.sl=realsl;
  thisuser.illegal=0;
  if (timer()<timeon)
    timeon-=24.0*3600.0;
  ton=timer()-timeon;
  thisuser.timeon += ton;
  thisuser.timeontoday += (ton-extratimecall);
  get_status();
  status.activetoday += (int) (ton/60.0);
  save_status();



  time(&l);
  thisuser.daten=l;
  close_user();
  write_user(usernum,&thisuser);
  close_user();

  sprintf(s,"Read: %d   Time on: %d",msgreadlogon,
        (int)((timer()-timeon)/60.0));

  if ((incom) || (thisuser.sl!=255))
    sl1(0,s);

  if (mailcheck) {
    strcpy(s,syscfg.datadir);
    strcat(s,"EMAIL.DAT");
    f=nopen(s,6);
    if (f!=-1) {
      t=(int) (filelength(f)/sizeof(mailrec));
      r=0;
      w=0;
      while (r<t) {
        lseek(f,(long)(sizeof(mailrec)) * (long)(r),SEEK_SET);
        read(f,(void *)&m,sizeof(mailrec));
        if ((m.tosys!=0) || (m.touser!=0)) {
          if (r!=w) {
            lseek(f,(long)(sizeof(mailrec)) * (long)(w),SEEK_SET);
            write(f,(void *)&m,sizeof(mailrec));
          }
          ++w;
        }
        ++r;
      }
      chsize(f,(long)(sizeof(mailrec)) * (long)(w));
      close(f);
    }
  }

  if (smwcheck) {
    strcpy(s,syscfg.datadir);
    strcat(s,"SMW.DAT");
    f=nopen(s,1);
    if (f!=-1) {
      t=(int) (filelength(f)/sizeof(shortmsgrec));
      r=0;
      w=0;
      while (r<t) {
        lseek(f,(long)(sizeof(shortmsgrec)) * (long)(r),SEEK_SET);
        read(f,(void *)&sm,sizeof(shortmsgrec));
        if ((sm.tosys!=0) || (sm.touser!=0)) {
          if (r!=w) {
            lseek(f,(long)(sizeof(shortmsgrec)) * (long)(w),SEEK_SET);
            write(f,(void *)&sm,sizeof(shortmsgrec));
          }
          ++w;
        }
        ++r;
      }
      chsize(f,(long)(sizeof(shortmsgrec)) * (long)(w));
      close(f);
    }
  }
  remove_from_temp("*.*",0);
  sprintf(s,"%sONLINE%d.DAT",syscfg.datadir,nodenum);
  remove(s); /* Remove User flag m0d */
  sprintf(s,"%sNETCHAT%d.PAG",syscfg.datadir,nodenum);
  remove(s); /* Remove NetChat page flag m0d */
}


int so()
{
  if (thisuser.sl==255)
    return(1);
  else
    return(0);
}



int cs()
{
  slrec ss;

  ss=syscfg.sl[thisuser.sl];
  if (so())
    return(1);
  if (ss.ability & ability_cosysop)
    return(1);
  else
    return(0);
}


int lcs()
{
  slrec ss;

  ss=syscfg.sl[thisuser.sl];
  if (cs())
    return(1);
  if (ss.ability & ability_limited_cosysop) {
    if (thisuser.sysopsub==255)
      return(1);
    if (thisuser.sysopsub==usub[cursub].subnum)
      return(1);
    else
      return(0);
  } else
    return(0);
}


void checka(int *abort, int *next)
{
  char ch;

  while ((!empty()) && (!(*abort)) && (!hangup)) {
    checkhangup();
    ch=inkey();
    switch(ch) {
      case 14:
        *next=1;
      case 3:
      case 32:
      case 24:
        *abort=1;
        break;
      case 'P':
      case 'p':
      case 19:
        ch=getkey();
        break;
    }
  }
}


void pla(char *s, int *abort)
{
  int i,next;

  i=0;
  checkhangup();
  if (hangup)
    *abort=1;
  checka(abort,&next);
  while ((s[i]) && (!(*abort))) {
    outchr(s[i++]);
    checka(abort,&next);
  }
  if (!(*abort))
    nl();
}


char *ctim(double d)
{
  static char ch[10];
  long h,m,s;

  h=(long) (d/3600.0);
  d-=(double) (h*3600);
  m=(long) (d/60.0);
  d-=(double) (m*60);
  s=(long) (d);
  sprintf(ch,"%02.2ld:%02.2ld:%02.2ld",h,m,s);

  return(ch);
}


int sysop2()
{
  int ok;

  ok=sysop1();
  if (restrict_chat & thisuser.restrict)
    ok=0;
  if (syscfg.sysoplowtime != syscfg.sysophightime) {
    if (syscfg.sysophightime>syscfg.sysoplowtime) {
      if ((timer()<=(syscfg.sysoplowtime*60.0)) || (timer()>=(syscfg.sysophightime*60.0)))
        ok=0;
    } else {
      if ((timer()<=(syscfg.sysoplowtime*60.0)) && (timer()>=(syscfg.sysophightime*60.0)))
        ok=0;
    }
  }
  return(ok);
}

void reqchat()
{
  int ok;
  char s[81];

  nl();
  nl();
  ok=sysop2();
  if (restrict_chat & thisuser.restrict)
    ok=0;
  if (ok) {
    if (chatcall) {
      chatcall=0;
      pl("Chat call turned off.");
      topscreen();
    } else {
      prt(2,"Reason: ");
      inputl(s,70);
      if (s[0]) {
        chatcall=1;
        strcpy(chatreason,"Chat: ");
        strcat(chatreason,s);
        nl();
        sysoplog(chatreason);
        for (ok=strlen(chatreason); ok<80; ok++)
          chatreason[ok]=32;
        chatreason[80]=0;
        topscreen();
        pl("Chat call turned ON.");
        nl();
      }
    }
  } else {
    pl("Sysop not available.");
    nl();
    pl("Use feedback instead.");
    strcpy(irt,"Tried Chatting.");
    imail(1,0);
  }
}


void yourinfo()
{
  char s[81];

  outchr(12);
  print("Your name      : ",nam(&thisuser,usernum),"");
  print("Phone number   : ",thisuser.phone,"");
  if (thisuser.waiting) {
    itoa((int)thisuser.waiting,s,10);
    print("Mail waiting   : ",s,"");
  }
  itoa((int)thisuser.sl,s,10);
  print("Sec Lev        : ",s,"");
  itoa((int)thisuser.dsl,s,10);
  print("Transfer SecLev: ",s,"");
  print("Last on        : ",thisuser.laston,"");
  itoa((int)thisuser.logons,s,10);
  print("Times on       : ",s,"");
  itoa((int)thisuser.ontoday,s,10);
  print("On today       : ",s,"");
  itoa((int)thisuser.msgpost,s,10);
  print("Messages posted: ",s,"");
  itoa((int)(thisuser.emailsent+thisuser.feedbacksent+thisuser.emailnet),s,10);
  print("E-mail sent    : ",s,"");
  ltoa((long) ((thisuser.timeon+timer()-timeon)/60.0),s,10);
  print("Time spent on  : ",s," Minutes","");
  nl();
}


void select_editor()
{
  char s[81],s1[81],*ss;
  int i;

  helpl=37;
  if (numed==0) {
    nl();
    pl("No full screen editors available.");
    nl();
    return;
  }
  for (i=0; i<5; i++)
    odc[i]=0;
  pl("0. Normal non-full screen editor");
  for (i=0; i<numed; i++) {
    itoa(i+1,s,10);
    strcat(s,". ");
    strcat(s,editors[i].description);
    pl(s);
    if (((i+1) %10)==0)
      odc[(i+1)/10-1]=(i+1)/10;
  }
  nl();
  strcpy(s,"Which editor (1-");
  itoa(numed,s1,10);
  strcat(s,s1);
  strcat(s,", <C/R>=leave as is) ? ");
  prt(2,s);
  ss=mmkey(2);
  i=atoi(ss);
  if ((i>=1) && (i<=numed))
    thisuser.defed=i;
  else
    if (strcmp(ss,"0")==0)
      thisuser.defed=0;
}


void print_cur_stat()
{
  char s[81],s1[81],s2[81];
  userrec ur;

  outchr(12);
  sprintf(s,"1. Screen size       : %d X %d",
        thisuser.screenchars,
        thisuser.screenlines);
  pl(s);
  strcpy(s,"2. ANSI              : ");
  if (thisuser.sysstatus & sysstatus_ansi)
    if (thisuser.sysstatus & sysstatus_color)
      strcat(s,"Color");
    else
      strcat(s,"Monochrome");
  else
    strcat(s,"No ANSI");
  pl(s);
  strcpy(s,"3. Pause on screen   : ");
  if (thisuser.sysstatus & sysstatus_pause_on_page)
    strcat(s,"On");
  else
    strcat(s,"Off");
  pl(s);
  strcpy(s,"4. Mailbox           : ");
  outstr(s);
  if ((thisuser.forwardsys==0) && (thisuser.forwardusr==0))
    pl("Normal");
  else {
    if (thisuser.forwardsys) {
      sprintf(s,"Forward to #%d @%d.",thisuser.forwardusr,thisuser.forwardsys);
      pl(s);
    } else {
      read_user(thisuser.forwardusr,&ur);
      if (ur.inact & inact_deleted) {
        thisuser.forwardusr=0;
        pl("Normal");
      } else {
        sprintf(s,"Forward to %s",nam(&ur,thisuser.forwardusr));
        pl(s);
      }
    }
  }
  strcpy(s,"5. Configured Q-scan");
  pl(s);
  strcpy(s,"6. Change password");
  pl(s);
  strcpy(s,"7. Update macros");
  pl(s);
  if (okansi()) {
    strcpy(s,"8. Change colors");
    pl(s);
    strcpy(s,"9. Full screen editor: ");
    if ((thisuser.defed) && (thisuser.defed<=numed))
      strcat(s,editors[thisuser.defed-1].description);
    else
      strcat(s,"None.");
    pl(s);
  }
  strcpy(s,"Q. Quit to main menu");
  pl(s);
  nl();
  nl();
}


char *cn(char c)
{
  static char s[20];

  if ((checkcomp("Ami")) || (checkcomp("Mac"))) {
    sprintf(s,"Color #%d",c);
    return(s);
  }

  switch(c) {
    case 0:
      return("Black");
    case 1:
      return("Blue");
    case 2:
      return("Green");
    case 3:
      return("Cyan");
    case 4:
      return("Red");
    case 5:
      return("Magenta");
    case 6:
      return("Yellow");
    case 7:
      return("White");
  }
  return("");
}

char *describe(char col)
{
  static char s[81];


  if (thisuser.sysstatus & sysstatus_color) {
    strcpy(s,cn(col & 0x07));
    strcat(s," on ");
    strcat(s,cn((col >> 4) & 0x07));
  } else {
    if ((col & 0x07) == 0)
      strcpy(s,"Inversed");
    else
      strcpy(s,"Normal");
  }
  if (col & 0x08) {
    if ((checkcomp("Ami")) || (checkcomp("Mac")))
      strcat(s,", Bold");
    else
      strcat(s,", Intense");
  }
  if (col & 0x80) {
    if (checkcomp("Ami"))
      strcat(s,", Italicized");
    else
      if (checkcomp("Mac"))
        strcat(s,", Underlined");
      else
        strcat(s,", Blinking");
  }
}

void color_list()
{
  int i;
  char s[81];

  nl();
  nl();
  for (i=0; i<8; i++) {
    if (i==0)
      makeansi(0x70,s);
    else
      makeansi(i,s);
    outstr(s);
    itoa(i,s,10);
    strcat(s,". ");
    strcat(s,cn(i));
    outstr(s);
    makeansi(0x07,s);
    outstr(s);
    nl();
  }
}



void change_colors()
{
  int i,done,i1,i2;
  char s[81],ch,nc;

  done=0;
  helpl=36;
  nl();
  do {
    if ((thisuser.sysstatus & sysstatus_color)==0) {
      strcpy(s,"Monochrome base color : ");
      if ((thisuser.bwcolors[1] & 0x70) == 0)
        strcat(s,cn(thisuser.bwcolors[1] & 0x07));
      else
        strcat(s,cn((thisuser.bwcolors[1] >> 4) & 0x07));
      pl(s);
      nl();
    }
    for (i=0; i<8; i++) {
      ansic(i);
      itoa(i,s,10);
      strcat(s,". ");
      switch(i) {
        case 0:
          strcat(s,"Default           ");
          break;
        case 1:
          strcat(s,"Yes/No            ");
          break;
        case 2:
          strcat(s,"Prompt            ");
          break;
        case 3:
          strcat(s,"Note              ");
          break;
        case 4:
          strcat(s,"Input line        ");
          break;
        case 5:
          strcat(s,"Yes/No Question   ");
          break;
        case 6:
          strcat(s,"Notice!           ");
          break;
        case 7:
	  strcat(s,"Elite Only!       ");
	  break;
      }
      if (thisuser.sysstatus & sysstatus_color)
        strcat(s,describe(thisuser.colors[i]));
      else
        strcat(s,describe(thisuser.bwcolors[i]));
      pl(s);
    }
    nl();
    prt(2,"Change which (0-6, Q=Quit) ? ");
    if (thisuser.ar & 16)                      /* Elite Color m0d */
	ch=onek("Q01234567");
    else
	ch=onek("Q0123456");
    if (ch=='Q')
      done=1;
    else {
      i1=ch-'0';
      if (thisuser.sysstatus & sysstatus_color)  {
        color_list();
        ansic(0);
        nl();
        prt(2,"Foreground? ");
	ch=onek("012345678");
        nc=ch-'0';
        prt(2,"Background? ");
	ch=onek("012345678");
        nc=nc | ((ch-'0') << 4);
      } else {
         nl();
         prt(5,"Inversed? ");
           if (yn()) {
             if ((thisuser.bwcolors[1] & 0x70) == 0)
               nc=0 | ((thisuser.bwcolors[1] & 0x07) << 4);
             else
               nc=(thisuser.bwcolors[1] & 0x70);
           } else {
             if ((thisuser.bwcolors[1] & 0x70) == 0)
               nc=0 | (thisuser.bwcolors[1] & 0x07);
             else
               nc=((thisuser.bwcolors[1] & 0x70) >> 4);
           }
      }
      if ((checkcomp("Ami")) || (checkcomp("Mac")))
        prt(5,"Bold? ");
      else
        prt(5,"Intensified? ");
      if (yn())
        nc |= 0x08;

      if (checkcomp("Ami"))
        prt(5,"Italicized? ");
      else
        if (checkcomp("Mac"))
          prt(5,"Underlined? ");
        else
          prt(5,"Blinking? ");
      if (yn())
        nc |= 0x80;

      nl();
      nl();
      makeansi(nc,s);
      outstr(s);
      outstr(describe(nc));
      ansic(0);
      nl();
      nl();
      prt(5,"Is this OK? ");
      if (yn()) {
        nl();
        pl("Color saved.");
        nl();
        if (thisuser.sysstatus & sysstatus_color)
          thisuser.colors[i1]=nc;
        else
          thisuser.bwcolors[i1]=nc;
      } else {
        nl();
        pl("Not saved, then.");
        nl();
      }
    }
  } while ((!done) && (!hangup));
}



void upload_post()
{
  char s[81],s1[81],ch;
  int i,i1,maxli,f;
  long l,l1;

  if (thisuser.sl<45)                /* Change Post Upload Size m0d */
    maxli=30;
  else
    if (thisuser.sl<60)
      maxli=50;
    else
      if (thisuser.sl<80)
        maxli=60;
      else
        maxli=80;
  strcpy(s,syscfg.tempdir);
  strcat(s,"INPUT.MSG");
  l1=100*(long)maxli;

  ltoa(l1,s1,10);
  nl();
  print("You may now upload a message, max ",s1," bytes.","");
  nl();
  receive_file(s,&i1,&ch,maxli,&ch,&ch);
  f=nopen(s,0);
  if (f>0) {
    l=filelength(f);
    if (l>l1) {
      nl();
      pl("Sorry, your message is too long.  Not saved.");
      nl();
      close(f);
      unlink(s);
    } else {
      close(f);
      use_workspace=1;
      nl();
      pl("Message uploaded.  The next post or email will contain that text.");
      nl();
    }
  } else {
    nl();
    pl("Nothing saved.");
    nl();
  }
}


int checkcomp(char *s)
{
  if (strstr(ctypes[thisuser.comp_type],s))
    return(1);
  else
    return(0);
}


