#include <sys\stat.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <alloc.h>
#include "vardec.h"
#include "fcns.h"


extern int hangup;
extern char dc[81],dcd[81],odc[81];
extern char charbuffer[161];
extern userrec thisuser;
extern int charbufferpointer,chatting;
extern int usernum,useron;
extern configrec syscfg;
extern int echo,smwcheck,okskey;
extern unsigned char realsl;
extern double timeon;
extern char curspeed[80];
extern unsigned int modem_speed,com_speed;
extern int cursub,curdir,curdloads,helpl;
extern usersubrec usub[32],udir[32];
extern statusrec status;
extern int incom,msgreadlogon,numchain;
extern int fsenttoday,userfile,chatcall;
extern char chatreason[81],irt[81];
extern subboardrec subboards[32];
extern smalrec *smallist;
extern chainfilerec *chains;
extern int nodenum;


int ok_local()
{
  if (syscfg.sysconfig& sysconfig_no_local)
    return(0);
  else
    return(1);
}


int finduser1(char *sx)
{
  int i,i1,i2;
  char s[81],s1[81],ch;
  userrec u;

  if (sx[0]==0)
    return(0);
  i=finduser(sx);
  if (i>0)
    return(i);
  strcpy(s,sx);
  for (i=0; s[i]!=0; i++)
    s[i]=upcase(s[i]);
  i2=0;
  for (i=0; (i<status.users) && (i2==0); i++) {
    if (strstr(smallist[i].name,s)!=NULL) {
      i1=smallist[i].number;
      read_user(i1,&u);
      sprintf(s1,"Do you mean %s (Y/N/Q) ? ",nam(&u,i1));
      prt(5,s1);
      ch=onek("QYN");
      if (ch=='Y')
	i2=i1;
      if (ch=='Q')
	i=status.users;
    }
  }
  return(i2);
}


void l_config_qscan()
{
  int i,abort;
  char s[81];

  abort=0;
  nl();
  pl("Boards to q-scan marked with '*'");
  nl();
  for (i=0; (i<32) && (usub[i].subnum!=-1) && (!abort); i++) {
    if ((1L << (usub[i].subnum)) & thisuser.qscn)
      strcpy(s,"* ");
    else
      strcpy(s,"  ");
    strcat(s,(usub[i].keys));
    strcat(s,". ");
    strcat(s,subboards[usub[i].subnum].name);
    pla(s,&abort);
  }
  nl();
  nl();
}

void config_qscan()
{
  char *s;
  int i,done;

  l_config_qscan();
  done=0;
  do {
    nl();
    pl("Enter sub-board identifier, or Q to Quit");
    helpl=7;
    outstr("Config: ");
    s=mmkey(0);
    if (s[0])
      for (i=0; i<32; i++)
        if (strcmp(usub[i].keys,s)==0)
          thisuser.qscn ^=((1L) << (usub[i].subnum));
    if (strcmp(s,"Q")==0)
      done=1;
    if (strcmp(s,"?")==0)
      l_config_qscan();
  } while ((!done) && (!hangup));
}


void list_macro(unsigned char *s)
{
  int i;

  i=0;
  outchr('"');
  while ((i<80) && (s[i]!=0)) {
    if (s[i]>=32)
      outchr(s[i]);
    else {
      outchr('^');
      outchr(s[i]+64);
    }
    ++i;
  }
  outchr('"');
  nl();
}


void make_macros()
{
  unsigned char tempmac[81],s[81];
  unsigned char ch,ch1;
  int i,i1,done,done1;

  done=0;
  do {
    nl();
    prt(2,"Macros: L:ist, M:ake, Q:uit  : ");
    helpl=33;
    ch=onek("QLM");
    switch(ch) {
      case 'Q':
        done=1;
        break;
      case 'L':
        nl();
        nl();
        pl("Ctrl-D macro: ");
        list_macro(&(thisuser.macros[0][0]));
        nl();
        pl("Ctrl-F macro: ");
        list_macro(&(thisuser.macros[1][0]));
        nl();
        pl("Ctrl-A macro: ");
        list_macro(&(thisuser.macros[2][0]));
        break;
      case 'M':
        nl();
        prt(2,"Which (A,D,F, Q=quit) : ");
        ch1=onek("QADF");
        if (ch1!='Q') {
          switch(ch1) {
            case 'A': i1=2; break;
            case 'D': i1=0; break;
            case 'F': i1=1; break;
          }
          strcpy(s,&(thisuser.macros[i1][0]));
          thisuser.macros[i1][0]=0;
          done1=0;
          i=0;
          nl();
          pl("Enter your macro now, hit ctrl-Z when done.");
          nl();
	  okskey=0;
          do {
            ch1=getkey();
            if (ch1==26)
              done1=1;
            else
              if (ch1==8) {
                if (i>0) {
                  i--;
                  backspace();
                  if (tempmac[i]<32)
                    backspace();
                }
              } else {
                if (ch1>=32) {
                  tempmac[i++]=ch1;
                  outchr(ch1);
                } else {
                  tempmac[i++]=ch1;
                  outchr('^');
                  outchr(ch1+64);
                }
              }
            if (i>=78)
              done1=1;
          } while ((!done1) && (!hangup));
	  okskey=1;
          tempmac[i]=0;
          nl();
          pl("You entered:");
          nl();
          nl();
          list_macro(tempmac);
          nl();
          prt(5,"Is this OK? ");
          if (yn()) {
            strcpy(&(thisuser.macros[i1][0]),tempmac);
            nl();
            pl("Macro saved.");
          } else {
            nl();
            strcpy(&(thisuser.macros[i1][0]),s);
            pl("Nothing saved, then.");
          }
        }
        break;
    }
  } while ((!done) && (!hangup));
}


void input_pw1()
{
  char s[81],s1[81];
  int ok;

  nl();
  prt(5,"Change password? ");
  if (yn()) {
    nl();
    pl("You must now enter your current password.");
    outstr(": ");
    echo=0;
    input(s,8);
    if (strcmp(s,thisuser.pw)) {
      nl();
      pl("Incorrect.");
      nl();
      return;
    }
    nl();
    nl();
    pl("Enter your new password, 3 to 8 characters long.");
    outstr(": ");
    echo=0;
    input(s,8);
    nl();
    nl();
    pl("Repeat password for verification.");
    outstr(": ");
    echo=0;
    input(s1,8);
    if (strcmp(s,s1)==0) {
      strcpy(thisuser.pw,s);
      nl();
      pl("Password changed.");
      nl();
      sysoplog("Changed Password.");
    } else {
      nl();
      pl("VERIFY FAILED.");
      pl("Password not changed.");
      nl();
    }
  }
}

void modify_mailbox()
{
  int i,i1,i2;
  unsigned int u;
  char s[81],*ss;
  float fl;

  nl();
  helpl=35;
  prt(5,"Do you want to forward your mail? ");
  if (!yn()) {
    thisuser.forwardsys=0;
    thisuser.forwardusr=0;
    return;
  }
  nl();
  if (syscfg.systemnumber) {
    prt(5,"Forward to another system? ");
    if (yn()) {
      nl();
      prt(2,"Which system (number)? ");
      input(s,5);
      i2=atoi(s);
      u=next_system(i2,&fl,&i1,&ss);
      if (u==65535) {
        nl();
        pl("Unknown system.");
        nl();
        return;
      }
      nl();
      print("System name: ",ss,"");
      nl();
      if (i2==syscfg.systemnumber) {
        nl();
        pl("That's this system.");
        nl();
        return;
      }
      prt(2,"Which user number on that system? ");
      input(s,5);
      i=atoi(s);
      if ((i>0) && (i<20000)) {
        thisuser.forwardsys=i2;
        thisuser.forwardusr=i;
        nl();
        pl("Saved.");
        nl();
      }
      return;
    }
  }
  nl();
  prt(2,"Forward to which user? ");
  input(s,40);
  i=finduser1(s);
  if (i==usernum) {
    thisuser.forwardsys=0;
    thisuser.forwardusr=0;
    nl();
    pl("Forwarding reset.");
    nl();
    return;
  }
  if (i>0) {
    thisuser.forwardsys=0;
    thisuser.forwardusr=i;
    nl();
    pl("Saved.");
    nl();
  }
}


void defaults()
{
  int i,i1,i2,done;
  char s[81],s1[81],s2[81],ch;

  done=0;
  print_cur_stat();
  do {
    nl();
    helpl=4;
    if (okansi()) {
      prt(2,"Defaults: (1-9,?,Q) : ");
      ch=onek("Q?123456789");
    } else {
      prt(2,"Defaults: (1-7,?,Q) : ");
      ch=onek("Q?1234567");
    }
    switch(ch) {
      case 'Q':
        done=1;
        break;
      case '?':
        print_cur_stat();
        break;
      case '1':
        input_screensize();
        break;
      case '2':
        input_ansistat();
        break;
      case '3':
        if (thisuser.sysstatus & sysstatus_pause_on_page)
          thisuser.sysstatus ^= sysstatus_pause_on_page;
        nl();
        prt(5,"Pause each screenfull? ");
        if (yn())
          thisuser.sysstatus |= sysstatus_pause_on_page;
        break;
      case '4':
        modify_mailbox();
        break;
      case '5':
        config_qscan();
        break;
      case '6':
        input_pw1();
        break;
      case '7':
        make_macros();
        break;
      case '8':
        change_colors();
        break;
      case '9':
	select_editor();
	break;
    }
  } while ((!done) && (!hangup));
}


void sl1(int cmd,char *s)
{
  static int midline=0,slf=-1;
  static char f[81];
  char l[180],ch1,s1[81];
  int i;

  switch(cmd) {
    case 0: /* Write line to sysop's log */
      if (slf<=0) {
	slf=nopen(f,2);
        if (filelength(slf)) {
          lseek(slf,-1L,SEEK_END);
          read(slf,((void *)&ch1),1);
          if (ch1==26)
            lseek(slf,-1L,SEEK_END);
        }
      }
      if (midline) {
        strcpy(l, "\r\n");
        strcat(l, s);
        midline = 0;
      } else
        strcpy(l,s);
      if (syscfg.sysconfig & sysconfig_printer)
        fprintf(stdprn,"%s\r\n",s);
      i=strlen(l);
      l[i++]='\r';
      l[i++]='\n';
      l[i]=0;
      write(slf,(void *)l,i);
      break;
    case 1: /* Close sysop's log */
      if (slf>0) {
        close(slf);
        slf=-1;
      }
      break;
    case 2: /* Set filename */
      if (slf>0) {
        close(slf);
        slf=-1;
      }
      strcpy(f,syscfg.gfilesdir);
      i=strlen(f);
      f[i++]=s[6];
      f[i++]=s[7];
      f[i++]=s[0];
      f[i++]=s[1];
      f[i++]=s[3];
      f[i++]=s[4];
      f[i]=0;
      sprintf(s1,"-%d.LOG",nodenum);
      strcat(f,s1);
      break;
    case 3: /* Close sysop's log  + return filename */
      if (slf>0) {
        close(slf);
        slf=-1;
      }
      strcpy(s,&f[strlen(syscfg.gfilesdir)]);
      break;
    case 4:
      if (slf <= 0) {
      slf = nopen(f,7);
      if (filelength(slf)) {
        lseek(slf, -1L, SEEK_END);
        read(slf, ((void *)&ch1), 1);
        if (ch1 == 26)
          lseek(slf, -1L, SEEK_END);
        }
      }
     if (!midline || ((midline + 2 + strlen(s)) > 78)) {
       strcpy(l, midline ? "\r\n   " : "   ");
       strcat(l, s);
       midline = 3 + strlen(s);
       }
     else {
       strcpy(l, ", ");
       strcat(l, s);
       midline += (2 + strlen(s));
       }
     if (syscfg.sysconfig & sysconfig_printer)
       fprintf(stdprn, "%s", l);
     i = strlen(l);
     write(slf, (void *)l, i);
     break;
  }
}

void sysopchar(char *s)
{
  if ((incom || (thisuser.sl != 255)) && (s[0]))
    sl1(4, s);
}

void sysoplog(char *s)
{
  char s1[180];

  if ((incom) || (thisuser.sl!=255)) {
    strcpy(s1,"   ");
    strcat(s1,s);
    sl1(0,s1);
  }
}


void read_automessage()
{
  int i,i1,i2,i3,f,len,ptrbeg[10],ptrend[10];
  char s[81],l[6][81],anon,buf[512];
  slrec ss;

  strcpy(s,syscfg.gfilesdir);
  strcat(s,"AUTO.MSG");
  f=nopen(s,0);
  nl();
  anon=status.amsganon;
  if (f<1) {
    pl("No auto-message.");
  } else {
    len=read(f,(void *)buf,512);
    close(f);
    for (i=0; i<10; i++) {
      ptrbeg[i]=0;
      ptrend[i]=0;
    }
    i=0;
    i1=0;
    i2=0;
    for(i=0; i<len; i++) {
      if (i1) {
        if (buf[i]==10) {
          ptrbeg[i2]=i+1;
          i1=0;
        }
      } else {
        if (buf[i]==13) {
          ptrend[i2]=i-1;
          if (i2<6) {
            for (i3=ptrbeg[i2]; i3<=ptrend[i2]; i3++)
              l[i2][i3-ptrbeg[i2]]=buf[i3];
              l[i2][ptrend[i2]-ptrbeg[i2]+1]=0;
          }
          ++i2;
          i1=1;
        }
      }
    }
    ss=syscfg.sl[thisuser.sl];
    if (anon)
      if (ss.ability & ability_read_post_anony) {
        strcpy(s,"<<< ");
        strcat(s,&(l[0][0]));
        strcat(s," >>>");
      } else
        strcpy(s,">UNKNOWN<");
    else
      strcpy(s,&(l[0][0]));
    nl();
    print("Auto message by: ",s,"");
    nl();
    i=1;
    while ((ptrend[i]) && (i<6)) {
      pl(&(l[i][0]));
      ++i;
    }
  }
  nl();
}

void write_automessage1()
{
  int i,i1,f;
  char s[81],l[4][81];
  slrec ss;

  nl();
  pl("Enter auto-message, 3 lines:");
  nl();
  for (i=0; i<3; i++) {
    outchr(i+'1');
    outchr(':');
    inputl(&(l[i][0]),39);
    strcat(&(l[i][0]),"\r\n");
  }
  nl();
  ss=syscfg.sl[thisuser.sl];
  if (ss.ability & ability_post_anony) {
    prt(5,"Anonymous? ");
    if (yn())
      i1=anony_sender;
    else
      i1=0;
  } else
    i1=0;
  prt(5,"Is this OK? ");
  if (yn()) {
    status.amsganon=i1;
    status.amsguser=usernum;
    save_status();
    strcpy(s,syscfg.gfilesdir);
    strcat(s,"AUTO.MSG");
    f=nopen(s,3);
    strcpy(s,nam(&thisuser,usernum));
    strcat(s,"\r\n");
    write(f,(void *)s,strlen(s));
    for (i=0; i<3; i++)
      write(f,(void *)&(l[i][0]),strlen(&(l[i][0])));
    sysoplog("Changed Auto-message");
    for (i=0; i<3; i++) {
      strcpy(s,"   ");
      l[i][strlen(&(l[i][0]))-2]=0;
      strcat(s,&(l[i][0]));
      sysoplog(s);
    }
    nl();
    pl("Auto-message saved.");
    nl();
    close(f);
  }

}

void write_automessage()
{
  char ch;
  int done,okwrite;
  slrec ss;

  ss=syscfg.sl[thisuser.sl];
  if (ss.posts)
    okwrite=1;
  else
    okwrite=0;
  if (thisuser.restrict & restrict_automessage)
    okwrite=0;
  done=0;
  do {
    nl();
    if (okwrite) {
      prt(2,"A-msg: R:ead, W:rite, A:uto-reply, Q:uit  : ");
      ch=onek("QRWA");
    } else {
      prt(2,"A-msg: R:ead, A:uto-reply, Q:uit  : ");
      ch=onek("QRA");
    }
    switch(ch) {
      case 'Q':
        done=1;
        break;
      case 'R':
        read_automessage();
        break;
      case 'W':
        write_automessage1();
        break;
      case 'A':
        if (status.amsguser)
          email(status.amsguser,0,0,status.amsganon);
        break;
    }
  } while ((!done) && (!hangup));

}


void bbslist()
{
  int i,i1,i2,f,done,ok;
  char s[150],s1[150],s2[150],ch,ch1,*ss;
  long l,l1;

  done=0;
  do {
    nl();
    prt(2,"BBS list: R:ead, A:dd, N:et, Q:uit  : ");
    ch=onek("QRNA");
    switch(ch) {
      case 'Q':
        done=1;
        break;
      case 'R':
        printfile("BBSLIST.MSG");
        break;
      case 'N':
	print_net_listing();
	break;
      case 'A':
        if ((thisuser.sl<=10)) {
          nl();
          nl();
          pl("You must be a validated user to add to the BBS list.");
          nl();
          break;
        }
	if (thisuser.restrict & restrict_automessage) {
          nl();
          nl();
          pl("You can not add to the BBS list.");
          nl();
          break;
	}
        nl();
        pl("Please enter phone number:");
        pl(" ###-###-####");
        outstr(":");
        mpl(12);
        input(s,12);
	if ((s[3]!='-') || (s[7]!='-'))
	  s[0]=0;
        if (strlen(s)==12) {
          ok=1;
          strcpy(s1,syscfg.gfilesdir);
          strcat(s1,"BBSLIST.MSG");
	  f=nopen(s1,2);
          if (f>0) {
            lseek(f,0L,SEEK_SET);
            l=filelength(f);
            if ((ss=malloca(l+500L))==NULL) {
              close(f);
              return;
            }
            read(f,ss,(int)l);
            l1=0L;
            while ((l1<l) && (ok)) {
              i=0;
              do {
                ch=ss[l1++];
                s1[i]=ch;
                if (ch==13)
                  s1[i]=0;
                ++i;
              } while ((ch!=10) && (i<120) && (l1<l));
              if (strstr(s1,s)!=NULL)
                ok=0;
	      if (strncmp(s1,s,12)==0)
		ok=0;
            }
            farfree(ss);
            close(f);
          }
          if (ok) {
            pl("Number not yet in BBS list.");
            nl();
            nl();
            pl("Enter BBS name and comments:");
            outstr(":");
            mpl(50);
            inputl(s1,50);
            strcat(s,"  ");
            strcat(s,s1);
            for (i=strlen(s); i<80; i++)
              s[i]=32;
            nl();
            pl("Enter maximum speed of the BBS:");
	    pl("ie, 300,1200,2400,9600,14.4,19.2");  /* 14.4k BBS List m0d */
            outstr(":");
            mpl(4);
            input(s1,4);
            s[66]='[';
            strcpy(&s[71-strlen(s1)],s1);
            strcpy(&s[71],"] (");
            s[74]=32;
            nl();
            pl("Enter BBS type (ie, WWIV):");
            outstr(":");
            mpl(4);
            input(s1,4);
            strcpy(&s[78-strlen(s1)],s1);
            s[78]=')';
            s[79]=0;
            nl();
            nl();
            pl(s);
            nl();
            prt(5,"Is this correct? ");
            if (yn()) {
              strcpy(s1,syscfg.gfilesdir);
              strcat(s1,"BBSLIST.MSG");
	      f=nopen(s1,2);
	      if (filelength(f)) {
                lseek(f,-1L,SEEK_END);
                read(f,((void *)&ch1),1);
                if (ch1==26)
                  lseek(f,-1L,SEEK_END);
	      }
              s[79]='\r';
              s[80]='\n';
              s[81]=0;
              write(f,(void *)s,81);
              close(f);
              nl();
              pl("Added to BBS list.");
            }
          } else {
            pl("It's already in the BBS list.");
            nl();
            nl();
          }
        } else {
	  nl();
	  pl("Please enter number in correct format.");
	  nl();
	}
        break;
    }
  } while ((!done) && (!hangup));
}


void kill_old_email()
{
  int cur,max,i,i1,f,done,done1,forward;
  char s[81],s1[81],ch;
  long l;
  mailrec m;
  userrec u;
  slrec ss;

  prt(5,"List mail starting at most recent? ");
  forward=(yn());
  ss=syscfg.sl[thisuser.sl];
  strcpy(s,syscfg.datadir);
  strcat(s,"EMAIL.DAT");
  f=nopen(s,6);
  if (f==-1) {
    nl();
    pl("No mail.");
    return;
  }
  max=(int) (filelength(f) / sizeof(mailrec));
  if (forward)
    cur=max-1;
  else
    cur=0;
  done=0;
  do {
    lseek(f,((long) cur) * sizeof(mailrec), SEEK_SET);
    read(f,(void *)&m,sizeof(mailrec));
    while (((m.fromsys!=0) || (m.fromuser!=usernum) || (m.touser==0)) && (cur<max) && (cur>=0)) {
      if (forward)
        --cur;
      else
        ++cur;
      if ((cur<max) && (cur>=0)) {
        lseek(f,((long) cur) * sizeof(mailrec), SEEK_SET);
        read(f,(void *)&m,sizeof(mailrec));
      }
    }
    if ((m.fromsys!=0) || (m.fromuser!=usernum) || (m.touser==0) || (cur>=max) || (cur<0))
      done=1;
    else {
      do {
        done1=0;
        nl();
        if (m.tosys==0) {
          read_user(m.touser,&u);
          strcpy(s1,nam(&u,m.touser));
          if ((m.anony & (anony_receiver | anony_receiver_pp | anony_receiver_da))
              && ((ss.ability & ability_read_email_anony)==0))
            strcpy(s1,">UNKNOWN<");
          print("To   : ",s1,"");
        } else {
          itoa(m.touser,s,10);
          itoa(m.tosys,s1,10);
          print("To   : User ",s1,", System ",s,"");
        }
        print("Title: ",m.title,"");
        time(&l);
        i=(int) ((l-m.daten)/24.0/3600.0);
        itoa(i,s,10);
        print("Sent : ",s," days ago","");
        nl();
        prt(2,"R:ead, D:elete, N:ext, Q:uit : ");
        ch=onek("QRDN");
        switch(ch) {
          case 'Q':
            done1=1;
            done=1;
            break;
          case 'N':
            done1=1;
            if (forward)
              --cur;
            else
              ++cur;
            if ((cur>=max) || (cur<0))
              done=1;
            break;
          case 'D':
            done1=1;
            delmail(f,cur);
            nl();
            pl("Mail deleted.");
            nl();
            sysoplog("Deleted mail.");
            break;
          case 'R':
            nl();
            nl();
            strcpy(s,"Title: ");
            strcat(s,m.title);
            pl(s);
            setorigin(0);
            read_message1(&m.msg,(m.anony & 0x0f), 0, &i1,"EMAIL");
            break;
        }
      } while ((!hangup) && (!done1));
    }
  } while ((!done) && (!hangup));
  close(f);
}

void list_users()
{
  subboardrec s;
  userrec u;
  int i,nu,abort,ok,num;
  char st[81],s1[181];

  if (usub[cursub].subnum==-1) {
    nl();
    pl("No sub!");
    nl();
    return;
  }
  s=subboards[usub[cursub].subnum];
  nl();
  pl("Users with access to current sub:");
  nl();
  sprintf(s1,"%-31.31s %-21.21s  %-8.8s  %-8.8s  %-4.4s"
    ,"Name and Number"
    ,"Score  Ranking","Last On","First On","Baud");
  pl(s1);
  pl("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  ~~~~~  ~~~~~~~~~~~~~~  ~~~~~~~~"
     "  ~~~~~~~~  ~~~~");
  abort=0;
  num=0;
  for (i=0; (i<status.users) && (!abort) && (!hangup); i++) {
    read_user(smallist[i].number,&u);
    ok=1;
    if (u.sl<s.readsl)
      ok=0;
    if (u.age<s.age)                           /* Userlisting m0d */
      ok=0;
    if ((s.ar!=0) && ((u.ar & s.ar)==0))
      ok=0;
    if (ok) {
      sprintf(s1,"%-31.31s %-21.21s  %8.8s  %8.8s  %-4d"
	    ,nam(&u,smallist[i].number)
	    ,u.note,u.laston,u.firston,u.lastrate);
      pla(s1,&abort);
      ++num;
    }
  }
  if (!abort) {
    itoa(num,st,10);
    nl();
    print(st," users.","");
    nl();
  }
}

void ssm(int un, int sy, char *s)
{
  int  f,i,i1;
  userrec u;
  char s1[81];
  shortmsgrec sm;

  if (sy!=0)
    return;
  strcpy(s1,syscfg.datadir);
  strcat(s1,"SMW.DAT");
  f=nopen(s1,2);
  i=(int) (filelength(f) / sizeof(shortmsgrec));
  i1=i-1;
  if (i1>=0) {
    lseek(f,((long) (i1)) * sizeof(shortmsgrec), SEEK_SET);
    read(f,(void *)&sm,sizeof(shortmsgrec));
    while ((sm.tosys==0) && (sm.touser==0) && (i1>0)) {
      --i1;
      lseek(f,((long) (i1)) * sizeof(shortmsgrec), SEEK_SET);
      read(f,(void *)&sm,sizeof(shortmsgrec));
    }
    if ((sm.tosys) || (sm.touser))
      ++i1;
  } else
    i1=0;
  sm.tosys=sy;
  sm.touser=un;
  strcpy(sm.message,s);
  lseek(f,((long) (i1)) * sizeof(shortmsgrec), SEEK_SET);
  write(f,(void *)&sm,sizeof(shortmsgrec));
  close(f);
  if (sy==0) {
    read_user(un,&u);
    u.sysstatus |= sysstatus_smw;
    if ((u.inact & inact_deleted)==0)
      write_user(un,&u);
    close_user();
  }
}

void rsm(int un, userrec *u)
{
  shortmsgrec sm;
  int i,i1,f,any;
  char s1[81];

  any=0;
  if ((u->sysstatus) & sysstatus_smw) {
    strcpy(s1,syscfg.datadir);
    strcat(s1,"SMW.DAT");
    f=nopen(s1,2);
    i=(int) (filelength(f) / sizeof(shortmsgrec));
    for (i1=0; i1<i; i1++) {
      lseek(f,((long) (i1)) * sizeof(shortmsgrec),SEEK_SET);
      read(f,(void *)&sm,sizeof(shortmsgrec));
      if ((sm.touser==un) && (sm.tosys==0)) {
        pl(sm.message);
        sm.touser=0;
        sm.tosys=0;
        sm.message[0]=0;
        lseek(f,((long) (i1)) * sizeof(shortmsgrec),SEEK_SET);
        write(f,(void *)&sm,sizeof(shortmsgrec));
	any=1;
      }
    }
    close(f);
    u->sysstatus ^= sysstatus_smw;
    smwcheck=1;
  }
  if (any)
    nl();
}


void print_quest(int f, int mapp, int map[21])
{
  char s[100];
  int i,abort;
  votingrec v;

  outchr(12);
  abort=0;
  for (i=1; (i<=mapp) && (abort==0); i++) {
    lseek(f,((long) (map[i])) * sizeof(votingrec), SEEK_SET);
    read(f,(void *)&v,sizeof(votingrec));
    if (thisuser.votes[map[i]])
      s[0]=32;
    else
      s[0]='*';
    s[1]=32;
    if (i<10)
      itoa(i,&s[2],10);
    else
      itoa(i,&s[1],10);
    strcat(s,": ");
    strcat(s,v.question);
    pla(s,&abort);
  }
  nl();
  if (abort)
    nl();
}


int print_question(int f, int i, int ii)
{
  char s[81],s1[81],s2[81];
  int i1,i2,i3,t,t1,abort;
  votingrec v;
  voting_response vr;

  lseek(f,((long) ii)*sizeof(votingrec),SEEK_SET);
  read(f,(void *)&v,sizeof(votingrec));
  abort=0;

  outchr(12);
  sprintf(s,"Voting question #%d:",i);
  pla(s,&abort);
  pla(v.question,&abort);
  pla("",&abort);
  t=0;
  for (i1=0; i1<v.numanswers; i1++) {
    vr=v.responses[i1];
    t+=vr.numresponses;
  }

  ltoa( (((long)t) * 1000L) / ((long)status.users),s1,10);
  i2=strlen(s1);
  if (i2>1) {
    strcpy(s2,s1);
    s2[i2-1]='.';
    s2[i2]=s1[i2-1];
    s2[i2+1]=0;
  } else {
    strcpy(s2,"0.");
    strcat(s2,s1);
  }
  strcpy(s,"Users voting: ");
  strcat(s,s2);
  strcat(s,"%");
  pla(s,&abort);
  pla("",&abort);
  if (t)
    t1=t;
  else
    t1=1;
  pla(" 0: No Comment",&abort);
  for (i1=0; i1<5; i1++)
    odc[i1]=0;
  for (i1=0; (i1<v.numanswers) && (!abort); i1++) {
    if (((i1+1) % 10)==0)
      odc[((i1+1)/10)-1]='0'+((i1+1)/10);
    s[0]=32;
    if (i1<9)
      itoa(i1+1,&s[1],10);
    else
      itoa(i1+1,&s[0],10);
    strcat(s,": ");
    vr=v.responses[i1];
    strcat(s,vr.response);
    for (i2=strlen(s); i2<64; i2++)
      s[i2]=32;
    s[64]=0;
    strcat(s," : ");
    itoa(vr.numresponses,s1,10);
    i3=4+strlen(s);
    for (i2=strlen(s); i2<i3-strlen(s1); i2++)
      s[i2]=32;
    s[i3-strlen(s1)]=0;
    strcat(s,s1);
    strcat(s,"  ");
    ltoa( (((long)vr.numresponses) * 1000L) / ((long)t1),s1,10);
    i2=strlen(s1);
    if (i2>1) {
      strcpy(s2,s1);
      s2[i2-1]='.';
      s2[i2]=s1[i2-1];
      s2[i2+1]=0;
    } else {
      strcpy(s2,"0.");
      strcat(s2,s1);
    }
    for (i2=0; i2<5-strlen(s2); i2++)
      strcat(s," ");
    strcat(s,s2);
    strcat(s,"%");
    pla(s,&abort);
  }
  nl();
  if (abort)
    nl();
  return(!abort);
}


void vote_question(int f, int i, int ii)
{
  int ok,pqo,i1,i2;
  char s[81],*ss;
  votingrec v;
  voting_response vr;

  pqo=print_question(f,i,ii);
  ok=pqo;
  ok=1;
  if (restrict_vote & thisuser.restrict)
    ok=0;
  if (thisuser.sl<=10)
    ok=0;
  if (!ok)
    return;

  lseek(f,((long) ii)*sizeof(votingrec),SEEK_SET);
  read(f,(void *)&v,sizeof(votingrec));

  strcpy(s,"Your vote: ");
  vr=v.responses[thisuser.votes[ii]-1];
  if (thisuser.votes[ii])
    strcat(s,vr.response);
  else
    strcat(s,"No Comment");
  pl(s);
  nl();
  prt(5,"Change it? ");
  if (!yn())
    return;

  prt(2,"Which? ");
  ss=mmkey(2);
  i1=atoi(ss);
  if (i1>v.numanswers)
    i1=0;
  if ((i1==0) && (strcmp(ss,"0")))
    return;

  if (thisuser.votes[ii]) {
    vr=v.responses[thisuser.votes[ii]-1];
    --vr.numresponses;
    v.responses[thisuser.votes[ii]-1]=vr;
  }
  thisuser.votes[ii]=i1;
  if (i1) {
    vr=v.responses[thisuser.votes[ii]-1];
    ++vr.numresponses;
    v.responses[thisuser.votes[ii]-1]=vr;
  }
  lseek(f,((long) ii)*sizeof(votingrec),SEEK_SET);
  write(f,(void *)&v,sizeof(votingrec));
/*  print_question(f,i,ii); */
/*  don't print out question again */
  nl();
  nl();
}


void vote()
{
  int i,i1,i2,f,map[21],mapp,abort,n,done;
  char s[81],s1[81],s2[81],sodc[10],*ss;
  votingrec v;

  strcpy(s,syscfg.datadir);
  strcat(s,"VOTING.DAT");
  f=nopen(s,2);
  n=(int) (filelength(f) / sizeof(votingrec)) -1;
  if (n<20) {
    v.question[0]=0;
    v.numanswers=0;
    for (i=n; i<20; i++)
      write(f,(void *)&v,sizeof(votingrec));
  }
  mapp=0;
  for (i=0; i<5; i++)
    odc[i]=0;
  for (i=0; i<20; i++) {
    lseek(f,((long) i) * sizeof(votingrec),SEEK_SET);
    read(f,(void *)&v,sizeof(votingrec));
    if (v.numanswers) {
      map[++mapp]=i;
      if ((mapp % 10)==0)
        odc[(mapp/10)-1]='0'+(mapp/10);
    }
  }
  strcpy(sodc,odc);
  if (mapp==0) {
    nl();
    nl();
    pl("No voting questions currently.");
    nl();
    close(f);
    return;
  }
  print_quest(f,mapp,&map[0]);
  done=0;
  do {
    nl();
    nl();
    prt(2,"Voting: Number,Q,? : ");
    strcpy(odc,sodc);
    ss=mmkey(2);
    i=atoi(ss);
    if ((i>0) && (i<=mapp))
      vote_question(f,i,map[i]);
    else
      if (strcmp(ss,"Q")==0)
        done=1;
      else
        if (strcmp(ss,"?")==0)
          print_quest(f,mapp,&map[0]);
  } while ((!done) && (!hangup));
  close(f);
}


void zlog()
{
  zlogrec z;
  char s[81];
  int abort,f,i,i1;

  strcpy(s,syscfg.datadir);
  strcat(s,"ZLOG.DAT");
  f=nopen(s,0);
  if (f<0)
    return;
  i=0;
  abort=0;
  read(f,(void *)&z,sizeof(zlogrec));
  pla("  Date     Calls  Active   Posts   Email   Fback    U/L    %Act   T/user",&abort);
  pla("--------   -----  ------   -----   -----   -----    ---    ----   ------",&abort);
  while ((i<97) && (!abort) && (!hangup) && (z.date[0]!=0)) {
    if (z.calls)
      i1=z.active/z.calls;
    else
      i1=0;
    sprintf(s,"%s    %4d    %4d     %3d     %3d     %3d    %3d     %3d      %3d",
	 z.date,z.calls,z.active,z.posts,z.email,z.fback,z.up,10*z.active/288,i1);
    pla(s,&abort);                                           /* Two node %Act m0d */
    ++i;
    if (i<97) {
      lseek(f,((long) i) * sizeof(zlogrec),SEEK_SET);
      read(f,(void *)&z,sizeof(zlogrec));
    }
  }
  close(f);
}


void show_chains(int *mapp, int *map)
{
  int abort,i,i1;
  char s[81];

  abort=0;
  nl();
  for (i=0; (i<*mapp) && (!abort) && (!hangup); i++) {
    itoa(i+1,s,10);
    strcat(s,". ");
    strcat(s,(chains[map[i]].description));
    pla(s,&abort);
  }
  nl();
}


void run_chain(int cn)
{
  char s[81],s1[81],s2[81];
  int oc;

  strcpy(s1,chains[cn].filename);
  strcpy(s2,create_chain_file("CHAIN.TXT"));
  stuff_in(s,s1,s2,"","","","");
  sprintf(s2,"!Ran '%s'",chains[cn].description);
  sysoplog(s2);
  oc=chatcall;
  chatcall=0;
  if (chains[cn].ansir & ansir_no_DOS) {
    set_protect(0);
    if (chains[cn].ansir & ansir_shrink)
      shrink_out(s,1,0,1);
    else
      run_external(s);
    topscreen();
  } else
    if (chains[cn].ansir & ansir_shrink)
      shrink_out(s,1,1,1);
    else
      full_external(s,0,1);
  chatcall=oc;
}



void do_chains()
{
  int map[50],mapp,i,i1,ok,done;
  char s[81],s1[81],*ss;
  chainfilerec c;

  mapp=0;
  for (i=0; i<10; i++)
    odc[i]=0;
  for (i=0; i<numchain; i++) {
    ok=1;
    c=chains[i];
    if ((c.ansir & ansir_ansi) && (!okansi()))
      ok=0;
    if ((c.ansir & ansir_no_300) && (modem_speed==300))
      ok=0;
    if (c.sl>thisuser.sl)
      ok=0;
    if (c.ar)
      if ((c.ar & thisuser.ar)==0)
        ok=0;
    if (ok) {
      map[mapp++]=i;
      if ((mapp % 10) ==0)
        odc[mapp/10 -1]='0'+(mapp/10);
    }
  }
  if (mapp==0) {
    nl();
    nl();
    pl("Sorry, no external programs available.");
    nl();
    return;
  }
  if (mapp==1) {
    run_chain(map[0]);
    return;
  }
  show_chains(&mapp,map);
  done=0;
  do {
    prt(2,"Which (Q=Quit, ?=List) : ");
    ss=mmkey(2);
    i=atoi(ss);
    if ((i>0) && (i<=mapp)) {
      done=1;
      run_chain(map[i-1]);
    } else
      if (strcmp(ss,"Q")==0)
        done=1;
      else
        if (strcmp(ss,"?")==0)
          show_chains(&mapp,map);
  } while ((!hangup) && (!done));
}
