#include <stdio.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <time.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <io.h>
#include <alloc.h>
#include <ctype.h>
#include <errno.h>
#include "vardec.h"
#include "fcns.h"

extern int hangup,incom,dlf,curdir;
extern configrec syscfg;
extern directoryrec directories[64];
extern userrec thisuser;
extern usersubrec udir[64];
extern unsigned int modem_speed,com_speed;
extern float batchtime,batchfntime[50];
extern int numbatch,batchdir[50],batchuldir[20],num_listed,numbatchul;
extern char batchfn[50][13],batchulfn[20][13],batchuldes[20][58];
extern int nodenum,usernum;

#define SETREC(i)  lseek(dlf,((long) (i))*((long)sizeof(uploadsrec)),SEEK_SET);

void delbatch(int i)
{
  int i1;

  if (i<numbatch) {
    batchtime -= batchfntime[i];
    --numbatch;
    for (i1=i; i1<=numbatch; i1++) {
      batchdir[i1]=batchdir[i1+1];
      batchfntime[i1]=batchfntime[i1+1];
      strcpy((batchfn[i1]),(batchfn[i1+1]));
    }
  }
}

void delbatchul(int i)
{
  int i1;

  if (i<numbatchul) {
    --numbatchul;
    for (i1=i; i1<=numbatchul; i1++) {
      batchuldir[i1]=batchuldir[i1+1];
      strcpy((batchuldes[i1]),(batchuldes[i1+1]));
      strcpy((batchulfn[i1]),(batchulfn[i1+1]));
    }
  }
}

void listbatch()
{
  char s[81];
  int abort,i;

  abort=0;
  if((!numbatchul) && (!numbatch)){
     nl();
     pl("No files in queue.");}
  if(numbatchul){
  nl();
  prt(1,"  Upload: ");
  sprintf(s,"Files - %d",numbatchul);
  pl(s);
  nl();
  for (i=0; (i<numbatchul) && (!abort) && (!hangup); i++) {
     sprintf(s,"          %d. %s",i+1,batchulfn[i]);
     pla(s,&abort);}
   }
  if(numbatch){
  nl();
  prt(1,"Download: ");
  sprintf(s,"Files - %d  Time - %s",numbatch,ctim(batchtime));
  pl(s);
  nl();
  for (i=0; (i<numbatch) && (!abort) && (!hangup); i++) {
    sprintf(s,"          %d. %s   %s",i+1,batchfn[i],ctim(batchfntime[i]));
    pla(s,&abort);
  }
  }
}

void batchdl()
{
  int i,abort,done,i1,i2,ok,had,rr,numb;
  char s[81],s1[300],ch,ch1,ch2;
  double percent;
  uploadsrec u;
  FILE *f;

  done=0;
  if ((!numbatch) && (!numbatchul)){
	  nl();
	  pl("No files in queue.");
	  nl();
	  pl("Use 'U' or 'D' to add files to queue.");
	 return;}
  do {
    nl();
    prt(2,"Batch/Bimodem: B,U,D,L,R,C,Q,? : ");
    ch=onek("Q?CLRDUB");
    switch(ch) {
      case '?':
        printmenu(9);
        break;
      case 'Q':
        done=1;
	break;
      case 'L':
        listbatch();
	break;
      case 'C':
	if(numbatchul){
	  nl();
	prt(5,"Clear upload queue? ");
        if (yn()) {
	  numbatchul=0;
	  pl("Upload queue cleared.");}
	}
	if(numbatch){
	 nl();
	prt(5,"Clear download queue? ");
	if (yn()){
	   numbatch=0;
	   batchtime=0.0;
	   pl("Download queue cleared.");}
	}
	if((!numbatch) && (!numbatchul)){
	  nl();
	  pl("No files in queue.");
	  done=1;
	  break;}
	break;
      case 'R':
	if(numbatchul){
	nl();
	prt(5,"Remove from upload queue which? ");
	input(s,2);
        i=atoi(s);
	if ((i>0) && (i<=numbatchul))
	  delbatchul(i-1);
	if (numbatchul==0) {
	  pl("Upload queue empty.");}
	}
	if(numbatch){
	nl();
	prt(5,"Remove from download queue which? ");
	input(s,2);
	i=atoi(s);
	if ((i>0) && (i<=numbatch))
	   delbatch(i-1);
	if (numbatch==0) {
	  pl("Download queue empty.");}
	}
	if((!numbatch) && (!numbatchul)){
	 nl();
	  pl("No files in queue.");
	  done=1;
	  break;}
	break;
		case 'B' :
		nl();
		prt(5,"Start bimodem transfer? ");
		if(!yn())
		  break;
		nl();
                prt(5,"Hang up after transfer? ");
		had=yn();
		nl();
		if (numbatch){
		f=fopen("bimodem.pth","a");
		for (i=0; (i<numbatch); i++) {
		strcpy(s1,directories[batchdir[i]].path);
		strcat(s1,stripfn(batchfn[i]));
		while (strlen(s1) < 240)
		    strcat(s1," ");
		fprintf(f,"U       %s",s1);}
		fclose(f);}
		if (numbatchul){
		f=fopen("bimodem.pth","a");
		for (i=0; (i<numbatchul); i++) {
		strcpy(s1,stripfn(batchulfn[i]));
		while (strlen(s1) < 80)
		    strcat(s1," ");
		strcat(s1,directories[batchuldir[i]].path);
		strcat(s1,stripfn(batchulfn[i]));
		while (strlen(s1) < 240)
		    strcat(s1," ");
		fprintf(f,"D       %s",s1);}
		fclose(f);}
		prt(1,"Invoke Bimodem-Remote Now (60 seconds till time-out) :");
		sprintf(s," %s ",thisuser.name);
		outs(s);
		strcpy(s1,"bimodem /B ");
		set_protect(0);
                itoa(modem_speed,s,10);
		strcat(s1,s);
		closedl();
		run_external(s1);
		topscreen();
		numb=numbatch;
		 for (i2=0; i2<numb; i2++)
		 {
		 dliscan1(batchdir[0],2);
		 i=recno((batchfn[0]));
		 lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
		 read(dlf,(void *)&u,sizeof(uploadsrec));
		 strcpy(s,directories[batchdir[0]].path);
		 strcat(s,u.filename);
		 ++thisuser.downloaded;
		 thisuser.dk += (int) ((u.numbytes+1023)/1024);
		 ++u.numdloads;
		 lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
		 write(dlf,(void *)&u,sizeof(uploadsrec));
		 strcpy(s,"-Downloaded using Bimodem '");
		 strcat(s,u.filename);
		 strcat(s,"'");
		 sysoplog(s);
		 closedl();
		 delbatch(0);}

		 remove("bimodem.pth");
		 batchul();
		 if(had)
		  hangup=1;
		 done=1;
		 break;
      case 'U' : /* Batch Upload/Bimodem Mod */
	  if(!numbatchul){
	    nl();
	    pl("No files in upload queue.");
	    nl();
	    pl("Type 'U' at the transfer menu to add files.");
	    break;
	    }
	  closedl();
	  nl();
	  pl("Batch Uploads MUST be sent in the same order that they appear in the queue!");
	  nl();
	  pl("Q: Quit");
	  pl("1: Zmodem");
	  pl("2: Ymodem");
	  pl("3: Ymodem-G");
	  nl();
	  prt(2,"Protocol : ");
	  ch1=onek("Q123");
	      switch(ch1){

	      case 'Q' :
		 break;
              case '1' :
		 nl();
		 prt(5,"Hang up after transfer? ");
		 had=yn();
		 nl();
		 sprintf(s,"%s is currently online.\n",thisuser.name);
		 outs(s);
		 nl();
		 strcpy(s,"dsz port 2 estimate 0 ");
		 itoa(modem_speed,s1,10);
		 strcat(s,s1);
		 strcat(s," rz ");
		 for(i=0;i<numbatchul;i++){
			 strcat(s,directories[batchuldir[i]].path);
			 strcat(s,stripfn(batchulfn[i]));
			 strcat(s," ");}
		 set_protect(0);
		 run_external(s);
		 batchul();
		 if(had)
		   hangup=1;
		 done=1;
		 break;
	      case '2' :
		 nl();
		 prt(5,"Hang up after transfer? ");
		 had=yn();
		 nl();
		 sprintf(s,"%s is currently online.\n",thisuser.name);
		 outs(s);
		 nl();
		 strcpy(s,"dsz port 2 estimate 0 ");
		 itoa(modem_speed,s1,10);
		 strcat(s,s1);
		 strcat(s," rb ");
		 for(i=0;i<numbatchul;i++){
			 strcat(s,directories[batchuldir[i]].path);
			 strcat(s,stripfn(batchulfn[i]));
			 strcat(s," ");}
		 set_protect(0);
		 run_external(s);
		 batchul();
		 if(had)
		   hangup=1;
		 done=1;
		 break;
	      case '3' :
		 nl();
		 prt(5,"Hang up after transfer? ");
		 had=yn();
		 nl();
		 sprintf(s,"%s is currently online.\n",thisuser.name);
		 outs(s);
                 nl();
		 strcpy(s,"dsz port 2 estimate 0 ");
		 itoa(modem_speed,s1,10);
		 strcat(s,s1);
		 strcat(s," rb -g ");
		 for(i=0;i<numbatchul;i++){
			 strcat(s,directories[batchuldir[i]].path);
			 strcat(s,stripfn(batchulfn[i]));
			 strcat(s," ");}
		 set_protect(0);
		 run_external(s);
		 batchul();
		 if(had)
		   hangup=1;
		 done=1;
		 break;
		 }
        break;
      case 'D':       /* Batch Protocol Menu Mod */
	nl();
	if(!numbatch){
	   pl("No files in download queue.");
	   nl();
	   pl("Type 'D' at the transfer menu to add files.");
	   break;}
	ansic(0);
	pl("Q: Quit");
	pl("1: Puma");
	pl("2: Zmodem");
	pl("3: Ymodem");
	pl("4: Ymodem-G");
	nl();
	prt(2,"Protocol : ");
	ch2=onek("Q1234");        /* Sloppy Batch Download Mod */
	switch(ch2)  {
	   case 'Q':
	      break;
	   case '3':
        if (!incom)
          break;
        nl();
        prt(5,"Hang up after transfer? ");
        had=yn();
        nl();
        sprintf(s,"Transmitting:  Files - %d  Time - %s",numbatch,ctim(batchtime));
        pl(s);
        nl();
        ok=1;
        rr=0;
        if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
          rr=1;
        if (thisuser.exempt & exempt_ratio)
          rr=0;
        if (rr) {
          nl();
          pl("Sorry, your ratio is too low.");
          nl();
          break;
        }
        do {
          tleft(1);
          if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
            rr=1;
          if (thisuser.exempt & exempt_ratio)
            rr=0;
          if ((nsl()>=batchfntime[0]) && (!rr)) {
	    dliscan1(batchdir[0],2);
            i=recno((batchfn[0]));
	    if (i<=0)
              delbatch(0);
	     else {
              sprintf(s,"%d files left, Time left = %s\r\n",numbatch,ctim(batchtime));
              outs(s);
              SETREC(i);
              read(dlf,(void *)&u,sizeof(uploadsrec));
              strcpy(s,directories[batchdir[0]].path);
	      strcat(s,u.filename);
	      closedl();
              xymodem_send(s,&ok,&percent,u.filetype,1,1,1);
	      if (ok) {
		dliscan1(batchdir[0],2);
                ++thisuser.downloaded;
                thisuser.dk += (int) ((u.numbytes+1023)/1024);
                ++u.numdloads;
                SETREC(i);
                write(dlf,(void *)&u,sizeof(uploadsrec));
                strcpy(s,"Downloaded '");
                strcat(s,u.filename);
                strcat(s,"'");
                sysoplog(s);
              }
            }
            closedl();
            delbatch(0);
          } else
            delbatch(0);
        } while ((ok) && (!hangup) && (numbatch>0) && (!rr));
        if ((ok) && (!hangup))
          endbatch();
        if (rr) {
          nl();
          pl("Your ratio is too low to continue the transfer.");
          nl();
        }
        if (had)
          hangup=1;
        done=1;
	break;
      case '2':
	bat_prot(1,&had);
	if(had)
	hangup=1;
	done=1;
	break;
     case '4':
	bat_prot(2,&had);
	if(had)
	hangup=1;
	done=1;
	break;
      case '1':
	bat_prot(3,&had);
	if(had)
	hangup=1;
	done=1;
	break;
    }
    break;
    }
  } while ((!done) && (!hangup));
}

int bat_prot(int t,int *had)
{
   FILE *f;
   int i,abort,done,rr,i2,numb;
   char s[81],xxx[81],s1[81];
   double percent;
   uploadsrec u;
   if (!incom)
   {
   *had=0;
   return(*had);
   }
   nl();
   prt(5,"Hang up after transfer? ");
   *had=yn();
   nl();
   nl();
   sprintf(s,"%s is currently online",thisuser.name);
   outs(s);
   nl();
   nl();
   sprintf(s,"Transmitting:  Files - %d  Time - %s",numbatch,ctim(batchtime));
   pl(s);
   nl();
   rr=0;
   if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
      rr=1;
   if (thisuser.exempt & exempt_ratio)
      rr=0;
   if (rr)  {
      nl();
      pl("Sorry, your ratio is too low.");
      nl();
      *had=0;
      return(*had);
   }
   strcpy(s,"BATCHDWN.LST");
   f=fopen("BATCHDWN.LST","w");
   for (i=0; (i<numbatch); i++)  {
      strcpy(xxx,directories[batchdir[i]].path);
      strcat(xxx,stripfn(batchfn[i]));
      fprintf(f,"%s\n",xxx);
   }
   fclose(f);
   switch(t)
   {                  /* Batch Protocol Command Lines Mod */
     case 1:
	    strcpy(s,"DSZ port 2 estimate 0 ");
	    itoa(modem_speed,s1,10);
	    strcat(s,s1);
	    strcat(s," sz -r @n:batchdwn.lst");
	    break;
     case 2:
	    strcpy(s,"DSZ port 2 estimate 0 ");
	    itoa(modem_speed,s1,10);
	    strcat(s,s1);
	    strcat(s," sb @n:batchdwn.lst");
	    break;
     case 3:
	    strcpy(s,"PUMA e");
	    itoa(modem_speed,s1,10);
	    strcat(s,s1);
	    strcat(s," s @n:BATCHDWN.LST");
	    break;
     default:
	    *had=0;
	    return(*had);
   }
   set_protect(0);
   run_external(s);
   topscreen();
/*   if(i!=0){          /* Aborted Download Mod
      numbatch=0;
      batchtime=0.0;
      pl("Transfer Aborted.");
      sysoplog("Batch Download Aborted!");
      *had=0;
      return(*had);} */
   numb=numbatch;
   for (i2=0; i2<numb; i2++)
   {
      dliscan1(batchdir[0],2);
      i=recno((batchfn[0]));
      if (i<=0)
      {
	 delbatch(0);
      } else
      {
	 lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
	 read(dlf,(void *)&u,sizeof(uploadsrec));
	 strcpy(s,directories[batchdir[0]].path);
	 strcat(s,u.filename);
	 ++thisuser.downloaded;
	 thisuser.dk += (int) ((u.numbytes+1023)/1024);
	 ++u.numdloads;
	 lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
	 write(dlf,(void *)&u,sizeof(uploadsrec));
	 switch (t)
	 {               /* Sysoplog Batch Download Message Mod */
	    case 1:
		   strcpy(s,"-Downloaded using Zmodem Batch '");
		   break;
	    case 2:
		   strcpy(s,"-Downloaded using Ymodem-G Batch '");
		   break;
	    case 3:
		   strcpy(s,"-Downloaded using Puma Batch '");
		   break;
	 }
	 strcat(s,u.filename);
	 strcat(s,"'");
	 sysoplog(s);
	 closedl();
	 delbatch(0);
      }
   }
   strcpy(s,"BATCHDWN.LST");
   remove(s);
   return(*had);
}


void gif_list() /* GIF List Mod */
{
   char s[81],s1[81],s2[81];
   int abort,next;

 nl();
 prt(2,"GIF File(s) to list [no extension]: ");
 mpl(8);
 input(s,8);
 if(strstr(s,".")){
   nl();
   prt(6,"Don't include extension!");
   return;}
 strcat(s,"*.GIF");
 align(s);
 dliscan();
 abort=0;
 next=0;
       strcpy(s1,directories[udir[curdir].subnum].path);
       strcat(s1,s);
       strcpy(s2,"GIFDIR ");
       strcat(s2,s1);
       nl();
       nl();
       ansic(5);
       if (do_external(s2,1))
	 abort=0;
       checka(&abort,&next);
       ansic(0);
closedl();
}

void batchul()
{

  uploadsrec u;
  int i,b,bd,ocd;
  char s[81],ff[81],des[81];

  ocd=curdir;
  b=1;
  i=0;
  nl();
  nl();
  nl();

while(i<numbatchul){

	  bd=batchuldir[i];
	  sprintf(s,"%d",bd);
	  strcpy(u.filename,batchulfn[i]);
	  strcpy(s,stripfn(batchulfn[i]));
	  strcpy(ff,directories[bd].path);
	  strcat(ff,s);
  if(exist(ff)){
	  dliscan1(bd,2);
	  curdir=bd;
	  strcpy(des,batchuldes[i]);
	  upload_file(u.filename,bd,b,des);
	  if(strstr(u.filename,".ZIP")){     /* ZIP Comment Mod */
		  strcpy(s,"pkzip -z ");
		  strcat(s,(directories[bd].path));
		  strcat(s,(stripfn(u.filename)));
		  strcat(s," <n:\\txt\\comment.asc");
		  run_external(s);}
          strcpy(s,u.filename);
	  strcat(s," UPLOADED!");
	  prt(1,s);
	  nl();}
  if(!exist(ff)){
	  strcpy(s,u.filename);
	  strcat(s," NOT UPLOADED!");
	  prt(6,s);
	  nl();}

  closedl();
  i++;}

   numbatchul=0;
   curdir=ocd;
      nl();
      nl();
      sprintf(s,"%-6.3f",ratio());
      print("Your ratio is now: ",s,"");
      topscreen();

}

void test_arc()
{
   char s[81],s1[81],s2[81];
   int i,abort,next,i1;
   uploadsrec u;

   nl();
   prt(2,"File to Test: ");
   mpl(12);
   input (s,12);
   if (strchr(s,'.')==NULL)
     strcat(s,".*");
   align(s);
   dliscan();
   abort=0;
   next=0;
   i=recno(s);
   do {
     if (i>0) {
       lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
       read(dlf,(void *)&u,sizeof(uploadsrec));
       if (compare(u.filename,"????????.ZIP")) {
	 strcpy(s1,directories[udir[curdir].subnum].path);
	 strcat(s1,stripfn(u.filename));
	 strcpy(s2,"PKUNZIP -T ");
	 strcat(s2,s1);
	 if (exist(s1)) {
	   nl(); nl();
	   ansic(2);
	   prompt("Testing archive integrity of ",u.filename,":","");
	   nl();
	   if (do_external(s2,1))
	     abort=1;
	     checka(&abort,&next);
	   }
	 }else
       if (compare(u.filename,"????????.GIF")) {    /* GIF Test Mod */
	  strcpy(s1,directories[udir[curdir].subnum].path);
	  strcat(s1,stripfn(u.filename));
	  strcpy(s2,"GT -T ");
	  strcat(s2,s1);
	  if (exist(s1)) {
	    nl(); nl();
	    ansic(2);
	    prompt("Testing GIF integrity of ",u.filename,":","");
	    nl(); nl();
	    if (do_external(s2,1))
	      abort=1;
	      checka(&abort,&next);
	  }
	}
	 i=nrecno(s,i);
       }
     } while ((i>0) && (!hangup) && (!abort));
     closedl();
}

void usertest()
{
      int i,i1,done,len,score,f,q;
      char s[1024],*b,ch,log[81];
      long l;

      q=0;
      i1=0;
      done=0;
      score=0;

      if(strcmp(thisuser.note,"")!=0)
	  return;
  do{
     strcpy(log,"Test: ");
     printfile("USERTEST.MSG");
     sprintf(s,"%sUSERTEST.DAT",syscfg.datadir);
     f=nopen(s,0);
     lseek(f,0L,SEEK_SET);
     l=filelength(f);
     if ((b=malloca(l+500L))==NULL) {
	 close(f);
	 done=1;
	 }
     len=read(f,b,(int)l);
     for(i=0;i<len;i++){
	s[i1]=b[i];
	if(s[i1]=='~')
	    done=1;
	if(s[i1]==':'){
	   s[i1]='\0';
	   nl(); nl();
	   prt(1,s);
	   nl();
	   prt(2,"Which? : ");
	   ch=onek("0123456789A");
	   if(ch==b[++i])
	      score++;
	   sprintf(s,"%c",ch);
	   strcat(log,s);
	   i1=0;
	   i++; i++;
	   q++;
	 }else
	   i1++;
      }
     done=1;
    }while((!hangup) && (!done));
farfree(b);
close(f);
if(score<10)
   sprintf(thisuser.note,"0%d/%d",score,q);
else
   sprintf(thisuser.note,"%d/%d",score,q);
if(score<4)
   strcat(thisuser.note,"  t0tal idi0t");
else
if((score>3) && (score<9))
   strcat(thisuser.note,"  r0dent");
else
if((score>8) && (score<16))
   strcat(thisuser.note,"  Poseur");
else
if((score>15) && (score<23))
   strcat(thisuser.note,"  Smartass");
else
   strcat(thisuser.note,"  Propellor-head");

strcat(log,"=");
strcat(log,thisuser.note);
sysoplog(log);

nl();
sprintf(s,"Score=%d/%d\n",score,q);
prt(1,s);
nl();
topscreen();
}


void pagecheck()
{
    char s[81],b[81],s1[81];
    int i,i1,f,len;

    i1=0;
    nl();
    for (i=1;i < 5;i++){
    sprintf(s1,"%sNETCHAT%d.PAG",syscfg.datadir,i);
    f=nopen(s1,0);
    if(f>0){
      len=read(f,(void *)b,81);
      close(f);
      for(i1=0;i1<len;i1++){
	s[i1]=b[i1];
	if(s[i1]=='\r'){
	   s[++i1]='\0';
	     break;
	}
      }
      if(i!=nodenum) {
	 prt(1,s);
	 nl();
	 pl("Hit 'C' at the Main or Transfer prompt for Chat Menu.");
	 remove(s1); }
      }
    }
}


int nodecheck()
{
    char s[81],b[81];
    int i,j,i1,f,len;

    i1=0;
    j=0;
    nl();
    for (i=1;i < 5;i++){
    sprintf(s,"%sONLINE%d.DAT",syscfg.datadir,i);
    f=nopen(s,0);
    if(f>0){
      len=read(f,(void *)b,81);
      close(f);
      for(i1=0;i1<len;i1++){
	s[i1]=b[i1];
	if(s[i1]=='\r'){
	   s[++i1]='\0';
	     break;
	}
      }
      if(i!=nodenum) {
	 j++;
	 pl(s);}
      else{
	 sprintf(s,"You are currently on node %d.",nodenum);
	 pl(s);}
      }
    }
return(j);
}

void makepage()
{
	int f;
	char s[256];
nl();
if(!nodecheck()) {
    pl("No one is on the other node.");
    return; }
prt(0,"Paging other node for NetChat...");
sprintf(s,"%sNETCHAT%d.PAG",syscfg.datadir,nodenum);
if((f=nopen(s,2))==-2) {
	printf("Access denied!\n");
	return;}
sprintf(s,"\7%s is paging you for NetChat.\r",nam(&thisuser,usernum));
write(f,(void *)s,strlen(s));
f=close(f);
nl();
}

void chatmenu()
{
	int done=0;
	int ch;
	char s[81];

do{
nl();
prt(2,"Chat: L,P,W,J,C,Q,? : ");
ch=onek("LPWJCQ?");
switch(ch) {
	case '?':
		printmenu(17);
		break;
	case 'L':
		if(!nodecheck())
			pl("No one is on the other node.");
		break;
	case 'P':
		makepage();
		break;
	case 'W':
		full_external("NETCHAT n:\\wwiv\\chat /u",0,1);
		topscreen();
		break;
	case 'J':
	       sprintf(s,"NETCHAT %s n:\\wwiv\\chat",nam(&thisuser,usernum));
	       full_external(s,0,1);
	       topscreen();
	       break;
	case 'C':
		reqchat();
		break;
	case 'Q':
		done=1;
		break;
	}
  }while(!done && !hangup);
}

int nopen(char *ofn, int a)
{
    int a1,f,c;

    c=0;

if (a==-2)
	   a1=O_RDONLY | O_DENYNONE | O_BINARY;
if (a==-1)
	   a1=O_RDONLY | O_DENYWRITE;
if (a==0)
	   a1=O_RDONLY | O_DENYWRITE | O_BINARY;
if (a==1)
	   a1=O_RDWR | O_BINARY | O_DENYALL;
if (a==2)
	   a1=O_RDWR | O_BINARY | O_DENYALL | O_CREAT;
if (a==3)
	   a1=O_RDWR | O_BINARY | O_DENYALL | O_CREAT | O_TRUNC;
if (a==4)
	   a1=O_RDWR | O_BINARY | O_DENYALL | O_CREAT | O_APPEND;
if (a==5)
	   a1=O_RDWR | O_BINARY | O_DENYALL | O_TRUNC;
if (a==6)
	   a1=O_RDWR | O_BINARY | O_DENYNONE;
if (a==7)
	   a1=O_RDWR | O_BINARY | O_DENYNONE | O_CREAT;

do {
       f=open(ofn,a1, S_IWRITE | S_IREAD);
       if (c==1){
	   prt(1,"\7Trying to open\7 ");
	   prt(1,ofn);
	   prt(1,"."); }
       if (c>1)
	   prt(1,".");
       c++;
} while((f==-1) && (c<40) && (errno==EACCES));

if (c>1)
    nl();

if ((f==-1) && (errno==EACCES)) {
       prt(2,"File in use by other node. Try again later.");
       nl();
       f=-2;
}

return(f);
}

void temp_arc_l()
{
  char s[81];

  nl();
  prt(2,"File for listing: ");
  input(s,12);
  if (!strchr(s,'.'))
    strcat(s,".ZIP");
  if (!okfn(s))
    return;
  list_arc_out(s,syscfg.tempdir);
  closedl();
}